      SUBROUTINE CALCUS
C
C     CALCULATE U'S AND SIGMAS IN CARTESIAN CRYSTAL SYSTEM
C ***   ADDED GOODNESS OF FIT ("GOF") 7.X.91
C ***   minor modif 14.IV.87, to include wtd R for Uii only
C ***   corrn line 60 29.X.87
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON/AMAT/AN(80,80)
      COMMON/AXESN/ISPAX(15),LT(5,15),LAT(5,15)
      COMMON/AXESC/LBAT(5,15)
      CHARACTER*4 LBAT
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig
      COMMON/IAID1/ IAIDX1(1000)
C * * Make common IO assignments.
      COMMON/IOSET/LI,LO,LTB
      DIMENSION SIGP(80),NRBP(150),AO(80),P(80),KAN(80)
      EQUIVALENCE(NRBP(1),IAIDX1(850))
      EQUIVALENCE (P(1),AIDX(801)),(SIGP(1),AIDX(881))
      EQUIVALENCE (AO(1),AIDX(1041)) , (KAN(1),AIDX(961))
      EQUIVALENCE (RWU,AIDX(2897))
      DOUBLE PRECISION  AN
C
      IF(NONRIG.EQ.0) GO TO 110
      DO 100 I = 1,NONRIG
      DO 100 J = 1,5
      LAT(J,I) = LT(J,I)
  100 CONTINUE
C          THAT RESTORES ORIGINAL ATOM-NUMBERS FOR DEFINING NON-RIGID
C         LIBRATION AXES.
      CALL DERNOP
C *** following line added June 7, 1991
      call local(1)
  110 NHP1 = NP1 + 1
      sdu = 0.
      sdg = 0.
      SUM = 0.
      SUMOB = 0.
      SUMDI = 0.
      SUMOBDI = 0.
      WSUM = 0.
      DO 10 K = 1,NTOT
      CALL DERIVP(K)
      IF(NRBP(K).EQ.0)  GO TO 15
      CALL DERNP(K)
   15 DO 10 K1 = 1,6
      AUCALC(K,K1) = 0.
      IF(UOBS(K,2).EQ.0.0) GO TO 10
C ***    SKIP ISOTROPIC ATOMS
c ***  Comment out next statement, 21.IV.87
C      IF(WU(K,K1).EQ.0.)  GO TO 10
      CALL INTSET(K1,I,L)
      CALL DERIV(I,L)
      IF(NONRIG.EQ.0)  GO TO 20
      IF(NRBP(K).EQ.0)  GO TO 25
      CALL DERNON(K,I,L)
      GO TO 20
   25 DO 26 I = NHP1,NNP1
      AO(I) = 0.
   26 CONTINUE
   20 DO 30 J = 1,NNP1
      AUCALC(K,K1) = AUCALC(K,K1) + AO(J)*P(J)
   30 CONTINUE
      IF(WT(K).EQ.800.0.OR.WT(K).EQ.999.9.OR.WT(K).LT.0.0) GO TO 10
C  ATOMS WITH THESE WEIGHTS NOT TO BE INCLUDED IN CALCULATION OF
C    AGREEMENT MEASURES
      IF(K.GT.NA)  GO TO 10
      DELTU = (AUOBS(K,K1) - AUCALC(K,K1))*WU(K,K1)
      SUM = SUM + (DELTU*DELTU)
      SUMOB = SUMOB +    (AUOBS(K,K1)*WU(K,K1))**2
      WSUM = WSUM+WU(K,K1)*WU(K,K1)
C * * Add logical IF to avoid zero divide when ISIG = 0
C PB      IF(ISIG.EQ.0) GO TO 10
C ***  next 3 lines new 7.X.91
C PB      du = AUOBS(K,K1) - AUCALC(K,K1)
C PB      sdu = sdu + du*du
C PB      sdg = sdg + (du/sigu(k,k1))**2
C ***  NEXT THREE LINES NEW 14.IV.87
      IF(K1.GT.3) GO TO 10
      SUMDI = SUMDI + DELTU*DELTU
      SUMOBDI = SUMOBDI + (AUOBS(K,K1)*WU(K,K1))**2
   10 CONTINUE
      IF(NONRIG.EQ.0)  GO TO 35
      NINPAR = NINPAR + (NNP1 - NP1)
      CALL OUTP18
C     PRINT ADJUSTED NUMBER OF INDEPENDENT PARAMETERS
C ***  CHANGE IN FOLLOWING LINES, 14.IV.87 TO BYPASS WHEN NINOBS = NINPAR
   35 IF(NINOBS.GT.NINPAR) GO TO 36
      NINOBS = NINPAR + 1
C ***  PRINT MESSAGE ABOUT ADJUSTMENT HAVING BEEN MADE
      WRITE(LO,901)
  901 FORMAT(1H ,'NINOBS EQUAL TO OR LESS THAN NINPAR.  ARBITRARILY SET
     1(NINOBS - NINPAR) = 1, TO PERMIT CONTINUING CALC.')
   36 SIG = (NMULT*SUM)/(NINOBS-NINPAR)
C ***  NMULT INSERTED IN PRECEDING LINE, 3.VI.84, BECAUSE SUM IS TAKEN
C ***    ONLY OVER UNIQUE ATOMS, WHILE MATRIX IS SUMMED (IN "SOLVE")
C ***    OVER ALL ATOMS (INCLUDING THOSE GENERATED BY SYMMETRY). IF
C ***    NMULT OMITTED, ESD'S ARE TOO SMALL BY SQUARE ROOT OF NMULT
C ***    WHEN CALCULATED FROM AN(I,I) IN LINE 8070 BELOW.  AN(I,I) IS
C ***    AT THIS POINT THE DIAGONAL ELEMENT OF THE INVERSE MATRIX
      RWU = SQRT(SUM/SUMOB)
      RMU = SQRT(SUM/WSUM)
      RWUDI = SQRT(SUMDI/SUMOBDI)
   45 DO 40 I = 1,NNP1
      SIGP(I) = SQRT(ABS(AN(I,I))*SIG)
   40 CONTINUE
      IF(IMAT.LT.100) GO TO 60
C *** PRINT WHEN IMAT.GE.100
      WRITE(LO,65)
      WRITE(LO,70) (J, SIGP(J), J = 1,NNP1)
   65 FORMAT(1H ,'ESDS OF THE PARAMETERS, IN ORDER (PRINTED BY SUBROUTIN
     1E CALCUS WHEN IMAT.GE.100)'/)
   70 FORMAT(1X,I5,5X,F15.8)
C     RMS OF THE DELTA U'S
C *** 6*(NA-N8) in next line changed to NINOBS, 10.X.91
   60 RMS = SQRT(SIG*FLOAT(NINOBS)/(NMULT*WSUM))
      GOF = SQRT(SDG/(NINOBS-NINPAR))
      RETURN
      END
