      SUBROUTINE CELLDI
C
C     CELLDI CALCULATES THE FULL SET OF THE REAL AND RECIPROCAL
C     CELLDIMENSIONS
C
      COMMON//AIDX(3000)
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      DIMENSION AH(3,3),DUM(3), RA(12), AHCD(12), GH(3,3)
      EQUIVALENCE (GH(1,1),AIDX(2416))
      EQUIVALENCE (AH(1,1),AIDX(801)),(DUM(1),AIDX(2401))
      DIMENSION GST(3,3)
      EQUIVALENCE (GST(1,1),AIDX(2891))
      EQUIVALENCE (RA(1),AIDX(1)), (AHCD(1),AIDX(2404))
C
C     CD(1) = A, CD(2) = B, CD(3) = C, CD(4) = ALPHA, CD(5) = BETA,
C     CD(6) = GAMMA, CD(7) = COS(ALPHA), CD(8) = COS(BETA),
C     CD(9) = COS(GAMMA), CD(10) = SIN(ALPHA), CD(11) = SIN(BETA)
C     CD(12) = SIN(GAMMA)
C     RCD(I)   ANALOGOUS FOR RECIPROCAL CELL DIMENSIONS
C
      RAD =  180./ 3.14159265359
      IF(CD(1).LT.1.)  GO TO 100
      IR = 1
      IF(CD(4).GT.1.)  GO TO 110
C     INPUT   REAL CELL WITH COSINES OF ANGLES
      DO 105 I = 4,6
      CD(I+3) = CD(I)
      CD(I) = ACOS(CD(I+3))
      CD(I+6) = SIN(CD(I))
  105 CD(I) = CD(I)*RAD
      GO TO 145
C     INPUT  REAL CELL WITH ANGLES
  110 DO 120 I = 4,6
      IF(CD(I).EQ.90.) GO TO 115
      IF(CD(I).EQ.120.) GO TO 117
      ANG = CD(I)/RAD
      CD(I+3) = COS(ANG)
      CD(I+6) = SIN(ANG)
      GO TO 120
  115 CD(I+3) = 0.
      CD(I+6) = 1.
      GO TO 120
  117 CD(I+3) = -.5
      CD(I+6)= 0.5*SQRT(3.)
  120 CONTINUE
      GO TO 145
  100 IR = 0
      DO 130 I = 1,3
  130 RCD(I) = CD(I)
      IF(CD(4).GT.1.)  GO TO 140
C     INPUT  RECIPROCAL CELL WITH COSINES OF ANGLES
      DO 135 I = 4,6
      RCD(I+3) = CD(I)
      RCD(I) = ACOS(RCD(I+3))
      RCD(I+6) = SIN(RCD(I))
  135 RCD(I) = RCD(I)*RAD
      GO TO 145
C     INPUT  RECIPROCAL CELL WITH ANGLES
  140 DO 142 I = 4,6
      RCD(I) = CD(I)
      IF(RCD(I).EQ.90) GO TO 143
      IF(RCD(I).EQ.60.) GO TO 144
      ANG = RCD(I)/RAD
      RCD(I+3) = COS(ANG)
      RCD(I+6) = SIN(ANG)
      GO TO 142
  143 RCD(I+3) = 0.
      RCD(I+6) = 1.
      GO TO 142
  144 RCD(I+3) = .5
      RCD(I+6) = .5*SQRT(3.)
  142 CONTINUE
  145 IF(IR.EQ.1)  GO TO 150
C     IR = 0, INPUT RECIPROCAL CELL
      DO 146 I = 1,12
  146 AHCD(I) = RCD(I)
  148 CALL GIK(GH,AHCD)
      DO 147 I = 1,3
      DO 147 K = 1,3
  147 AH(I,K) = GH(I,K)
      CALL MATINV(AH,3,3,0,DUM,DET)
      VH = SQRT(DET)
      DO 160 I = 1,3
      RA(I) = SQRT(AH(I,I))
  160 CONTINUE
      RA(7) = AH(2,3)/(RA(2)*RA(3))
      RA(8) = AH(1,3)/(RA(1)*RA(3))
      RA(9) = AH(1,2)/(RA(1)*RA(2))
      DO 149 I = 1,3
      RA(I+3) = ACOS(RA(I+6))
      RA(I+9) = SIN(RA(I+3))
      RA(I+3) = RA(I+3) * RAD
  149 CONTINUE
      IF(IR.EQ.1)  GO TO 190
      DO 180 I = 1,12
  180 CD(I) = RA(I)
      DO 182 I = 1,3
      DO 182 K = 1,3
      G(I,K) = AH(I,K)
      GST(I,K) = GH(I,K)
  182 CONTINUE
      VST = VH
      VOL = 1./VST
      GO TO 200
C     IR = 1, INPUT REAL CELL
  150 DO 152 I = 1,12
  152 AHCD(I) = CD(I)
      GO TO 148
  190 DO 192 I = 1,12
  192 RCD(I) = RA(I)
      DO 194 I = 1,3
      DO 194 K = 1,3
      G(I,K) = GH(I,K)
      GST(I,K) = AH(I,K)
  194 CONTINUE
      VOL = VH
      VST = 1./VOL
  200 EPS = 0.0005
      DO 205 I = 4,6
      ACD = ABS(CD(I) - 90.)
      IF(ACD.GT.EPS)  GO TO 210
  205 CONTINUE
      NANG = 0
C     NANG = 0, ALPHA=BETA=GAMMA=90 DEG.  ORTHOG.SYSTEM
      RETURN
  210 NANG = 1
      RETURN
      END
