      SUBROUTINE INERT
C
C     CALCULATE AXIAL SYSTEM OF INERTIA, DETERMINE TRANSFORMATION
C     MATRICES AND (WHEN ISOLV = 1, AFTER GETTING L,T,S IN CARTESIAN
C     CRYSTAL SYSTEM) TRANSFORM NTOTs ATOMS INTO THE INERTIAL SYSTEM.
C *****Modified by EFM March 1991 to print coordinates for NTOTS (all)
C *****atoms IN THE INERTIAL SYSTEM
C     MODIFIED JANUARY 1982 TO TRANSFORM ESD OF U'S CORRECTLY, OR AT
C       LEAST MORE CORRECTLY, USING THE PROPOSED ISOTROPIC COVARIANCE
C       TENSOR OF HIRSHFELD AND SHMUELI, ACTA CRYST A28, 649-652 ('72)
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2  IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT2/ NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig
      COMMON/CORDIN/ IRIDE,IMIN,IUNC, IHAT(150), NUNC(20), TUNC(20,3),
     1 TOR(3,3), XCG(3),IHPR
      common/inerta/axi(150,3),auobsi(150,6)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
      COMMON/TMCSIS/TCIC(3,3),TCIU(3,3),TCINVC(3,3),TCINVU(3,3),SCG(3),
     1 OMIN(3,3), TROI(3,3)
C
C * * Make common IO assignments.
      COMMON/IOSET/LI,LO,LTB
      DIMENSION TORIN(3,3)
      DIMENSION AXX(150,3), AXWT(150)
      DIMENSION VH(3),AXH(3),AH(3),TTCIU(3,3)
      DIMENSION OMA(3,3),AUO(3,3),TOMA(3,3),TTROI(3,3)
      DIMENSION DUM(3),EIGV(3),UH(3,3),XICG(3),CGM(3,3)
C
      EQUIVALENCE (TORIN(1,1),AIDX(1968))
      EQUIVALENCE (TTCIU(1,1),AIDX(1948))
      EQUIVALENCE (OMA(1,1),AIDX(2010))
      EQUIVALENCE (AUO(1,1),AIDX(2046)),(VH(1),AIDX(2055))
      EQUIVALENCE (AXH(1),AIDX(2058))
      EQUIVALENCE (AXX(1,1),AIDX(1)),(AXWT(1),AIDX(601))
      EQUIVALENCE (TTROI(1,1),AIDX(1935))
      EQUIVALENCE (AH(1),AIDX(1945)), (DPL,AIDX(1913))
      EQUIVALENCE (DUM(1),AIDX(2401)),(EIGV(1),AIDX(798))
      EQUIVALENCE (CGM(1,1),AIDX(1903))
      EQUIVALENCE (UH(1,1),AIDX(1914)),(XICG(1),AIDX(1932))
      EQUIVALENCE (WDSQ,AIDX(1958)),(TOMA(1,1),AIDX(1959))
C
      REAL   MULT
      CHARACTER*4 NAME1,ATNAME,TISET,TITLE*80, ITBL*3, NAME2*5
C
      NAH = NA + NA1
      if(isolv.ne.0) go to 110
      DO 5 I = 1,3
      XCG(I) = 0.
      DO 5 J = 1,3
      CGM(I,J) = 0.
    5 CONTINUE
      SUMW = 0.
      DO 300 I = 1,3
      DO 300 J = 1,3
      TORIN(I,J) = TOR(I,J)
      OMIN(I,J) = OMA(I,J)
  300 CONTINUE
      CALL MATINV(TORIN,3,3,0,DUM,DET)
      CALL MATINV(OMIN,3,3,0,DUM,DET)
C     PRINT TRANSFORMATION MATRICES FROM CRYSTAL SYSTEM TO ORTHOGONAL
C     SYSTEM AND THEIR INVERSES
      IF(NS.LT.(-3).OR.NS.EQ.(-2)) GO TO 305
      CALL OUTH18
      CALL OUTH15
      CALL OUTP11
      CALL OUTH14
      CALL OUTP13
      CALL OUTP20
      CALL OUTH17
  305 DO 10 I = 1,ICOUNT
C *** ICOUNT = TOTAL NO ATOMS FOR INERTIAL SYSTEM, GENERATED IN SYMPOS
C ***    AXX  ARE, INITIALLY, THE CRYSTAL-SYSTEM POSNS OF THOSE ATOMS
      CALL VECH(AXX,I,VH)
      CALL MATVEC(TOR,VH,AXH)
      CALL ARRVE(AXX,I,AXH)
C ***    AXX  ARE, NOW, POSITIONS IN THE CARTESIAN CRYSTAL SYSTEM
      IF(AXWT(I).LT.0.)   AXWT(I) =(-1.)* AXWT(I)
C   AXWT(I) IS INPUT WT MULTIPLIED BY MULT (IN  SYMPOS)
C     BUT MULT(I) IS DEFINED ONLY FOR FIRST NTOT ATOMS, WHILE
C     AXWT(I) IS DEFINED FOR NAH TIMES NMULT ATOMS, WITH
C     NAH = NA + NA1 = NO. OF UNIQUE ATOMS FOR INERTIAL TENSOR
      II = I
  306 IF(II.LE.NAH) GO TO 307
      II = II - NAH
      GO TO 306
  307 W = AXWT(I)/MULT(II)
      IF(W.EQ.800.0) AXWT(I) = 0.0
C   ATOMS WITH WT 800.0 IGNORED IN CALCULATION OF INERTIA TENSOR
      SUMW = SUMW + AXWT(I)
      DO 15 K = 1,3
      AH(K) = AXWT(I)*AXX(I,K)
      XCG(K) = XCG(K) + AH(K)
C ***    XCG IS MOLECULAR CENTER OF GRAVITY IN CARTESIAN CRYSTAL SYSTEM
      DO 15 J = 1,3
      CGM(K,J) = CGM(K,J) + AH(K)*AXX(I,J)
   15 CONTINUE
   10 CONTINUE
      DO 20 I = 1,3
      XCG(I) = XCG(I)/SUMW
   20 CONTINUE
      DO 25 I = 1,3
      DO 25 K = 1,3
      CGM(I,K) = CGM(I,K) - SUMW*XCG(I)*XCG(K)
   25 CONTINUE
C     INERTIA SYSTEM WITH CENTER IN CENTER OF GRAVITY
      CALL EIGEN(CGM,TROI,3)
      WDSQ = CGM(3,3)/SUMW
      CALL TRAMA(TROI,TTROI)
      CALL MATVEC(TTROI,XCG,XICG)
      CALL DOUBLE(TTROI,TOR,TCIC)
C     TCIC = TRANSFORMATION MATRIX FOR COORDINATES FROM CRYSTAL TO
C     INERTIAL SYSTEM
C     TCIU = TRANSFORMATION MATRIX FOR UOBS FROM CRYSTAL TO INERTIAL SYS
C     TCIU*UOBS*TTCIU
C     TTCIU = TRANSPOSE OF TCIU
      CALL DOUBLE(TTROI,OMA,TCIU)
      CALL TRAMA(OMA,TOMA)
      IF(NO.EQ.1) NTOTS = NTOT
      DO 200 K = 1,NTOTS
      CALL VEMA(UOBS,AUO,K)
      CALL TRIPLE(OMA,AUO,TOMA,UH)
      CALL MAVE(UH,AUOBS,K)
C      AUOBS ARE NOW U'S IN CARTESIAN CRYSTAL SYSTEM
      CALL VECH(X,K,VH)
      CALL MATVEC(TOR,VH,AH)
      DO 200 I = 1,3
      AX(K,I) = AH(I) - XCG(I)
C      AX(K,I) ARE NOW CARTESIAN CRYSTAL POSITIONS REL TO C OF MASS
  200 CONTINUE
      DO 35 K = 1,NTOT
      CALL VECH(X,K,VH)
      CALL MATVEC(TOR,VH,AH)
      DO 35 I = 1,3
      AXX(K,I) = AH(I)
C      AXX(K,I) ARE CARTESIAN COORDINATES OF ALL NTOT ATOMS RELATIVE TO
C        THE CRYSTAL ORIGIN, FOR OUTPUT AND CHECKING
   35 CONTINUE
      IF(ISIG.LE.0) GO TO 120
C      IF (ISIG.EQ.0) NO SIGU'S INPUT.
C      IF (ISIG.LT.0),  INPUT SIGU'S ARE WORKING WEIGHTS AND ARE NOT
C        TRANSFORMED.  IF IWU.EQ.1, SIGU USED ONLY TO GET AVE SIGMA.
      IF(IWU.EQ.1) GO TO 120
C     CONVERT INPUT SIGB TO WU1 FOR CALCULATION WEIGHTED RMS DELTA U IN
C      CRYSTAL SYSTEM (IN UCRYST)
      DO 392 I=1,NA
      DO 392 K=1,6
C ***   NEXT TWO LINES INSERTED 20.IV.87; ANY SIGB=0. NOW LEFT IN  MAIN
      WU1(I,K) = 0.
      IF(SIGB(I,K).EQ.0.) GO TO 392
      WU1(I,K) = SUMSIG/SIGB(I,K)
  392 CONTINUE
C      SUBROUTINE  SGTRAN   TRANSFORMS SIGMAS OF U'S.
C ***    PRINT H-S VARIANCE-CHECK TABLE IF NS NON-NEG
  400 IF(NS.GE.0) CALL OUTH6
      IF(NS.GE.0) CALL OUTH31
      MM = 1
      CALL SGTRAN(OMA,SIGB,SIGU,NTOTS,MM)
C      TRANSFORMED SIGB ARE NOW PRESENT AS SIGU FOR ABS(ISIG) ATOMS
C       AND, IF SOME SYMMETRY-GENERATED ATOMS AS WELL, FOR THOSE ALSO
  120 IF(NS.EQ.(-3).OR.NS.GT.(-2)) CALL OUTH6
      DO 45 I = 1,3
      DO 45 K = 1,3
      TCINVC(I,K) = TCIC(I,K)
      TCINVU(I,K) = TCIU(I,K)
   45 CONTINUE
      CALL MATINV(TCINVC,3,3,0,DUM,DET)
      CALL MATINV(TCINVU,3,3,0,DUM,DET)
C     BACKTRANSFORMATION FROM INERTIAL TO CRYSTAL SYSTEM
C     COORDINATES  TCINVC*AX + SHIFT FOR CENTER OF GRAVITY
C     U'S  TCINVU*AUOBS*TTCNVU
      IF(NS.EQ.(-2).OR.NS.LT.(-3)) GO TO 220
      CALL OUTH12
      CALL OUTH15
C     PRINT TCIC
      CALL OUTP1
      CALL OUTH14
C     PRINT TCIU
      CALL OUTP2
      CALL OUTH16
      CALL OUTH15
C          PRINT TCINVC
      CALL OUTP8
      CALL OUTH14
C          PRINT TCINVU
      CALL OUTP9
      CALL OUTH17
      IF(NS.LT.0) GO TO 220
      CALL OUTH6
C     PRINT COORDINATES IN CARTESIAN CRYSTAL SYSTEM
      CALL OUTH19
      CALL OUTH32
      CALL OUTH20
      KOUTP = 3
      CALL OUTP15
  220 EIGV(1) = CGM(2,2) + CGM(3,3)
      EIGV(2) = CGM(1,1) + CGM(3,3)
      EIGV(3) = CGM(1,1) + CGM(2,2)
      CALL MATVEC(TCINVC,XICG,SCG)
      DPL = 0.
      DO 50 I = 1,3
      DPL = DPL + (TCIC(3,I)*SCG(I))
   50 CONTINUE
      CALL TRAMA(TCIU,TTCIU)
      NTOTI=NTOT
      IF(NTOT.NE.NTOTS)NTOTI=NTOTS
      DO 500  K = 1,NTOTI
      CALL VEMA(UOBS,AUO,K)
      CALL TRIPLE(TCIU,AUO,TTCIU,UH)
      CALL MAVE(UH,AUOBSI,K)
      CALL VECH(X,K,VH)
      CALL MATVEC(TCIC,VH,AH)
C     TO TAKE CARE OF THE SHIFT OF THE ORIGIN THE COMPONENTS OF THE
C       VECTOR TO THE CENTER OF GRAVITY HAVE TO BE SUBTRACTED
      CALL MATVEC(TCIC,SCG,XICG)
C     C. OF M. IS AT SCG IN CRYSTAL SYSTEM, AT XICG IN INERTIAL SYSTEM
      DO 500 I = 1,3
      AXI(K,I) = AH(I) - XICG(I)
  500 continue
      IF(NS.EQ.(-2).OR.NS.LT.(-3)) return
      IF(NTOT.GT.15.OR.NS.EQ.(-1).OR.NS.EQ.(-3)) CALL OUTH6
C     PRINT EIGENVALUES AND EIGENVECTORS OF THE TENSOR OF INERTIA,
C     PRINT CENTER OF MASS REFERRED TO THE CRYSTAL SYSTEM AND
C     DISTANCE OF THE BEST PLANE
      CALL OUTP19
C *****EFM PRINT ALL coordinates in inertial system here
      IF(NANG.NE.0.OR.NTOT.GT.15.OR.NS.GE.0) CALL OUTH6
      CALL OUTH10
C     PRINT COORDINATES AND DISPLACEMENT PARAMETERS IN THE AXIAL
C     SYSTEM OF INERTIA
C ***** EFM changed 3/91 to print coordinates for symmetry-related
C ***** atoms also
      KOUTP = 2
      IF(NTOT.NE.NTOTS)KOUTP=5
      CALL OUTP15
      return
C ***  redocalc of inertial U's and call them AUOBS, AUCALC, because
C ***    program used to look for them at this stage by that name
C ***    and I'm not prepared 3.X.91 to search for all the places
  110 CALL TRAMA(TCIU,TTCIU)
      NTOTI=NTOT
      IF(NTOT.NE.NTOTS)NTOTI=NTOTS
      DO 40  K = 1,NTOTI
      CALL VEMA(UOBS,AUO,K)
      CALL TRIPLE(TCIU,AUO,TTCIU,UH)
      CALL MAVE(UH,AUOBS,K)
      CALL VEMA(UCALC,AUO,K)
      CALL TRIPLE(TCIU,AUO,TTCIU,UH)
      CALL MAVE(UH,AUCALC,K)
   40 CONTINUE
      RETURN
      END
