      SUBROUTINE LFRAME
C
C     ROTATE S AND T TO L FRAME, CALCULATE SHIFT OF ORIGIN TO REDUCE
C     TRACE OF  T AND SYMMETRIZE  S,SEE SCHOMAKER AND TRUEBLOOD,
C     ACTA CRYST(1968) B24,63, EQUATIONS P.67
C
C     VL = EIGENVECTORS OF L IN I FRAME
C     AHL(I,I) = EIGENVALUES L IN I FRAME
C     VLT = TRANSPOSE OF VL
C     PT = ORIG. T TENSOR IN I FRAME(VECTORIAL SEQUENCE)
C     AAHT(3,3)= ORIG. T TENSOR IN I FRAME
C     AHT = EIGENVALUES OF ORIGINAL T TENSOR IN I FRAME
C     VT = EIGENVECTORS OF ORIGINAL T TENSOR IN I FRAME
C     AHS(3,3) = ORIG. S TENSOR IN I FRAME
C     RO (3) = ORIGIN SHIFT IN I FRAME
C     TNEW = NEW T TENSOR IN I FRAME
C     TNEWE = EIGENVALUES OF NEW T IN I FRAME
C     TNEWV = EIGENVECTORS OF NEW T IN I FRAME
C     SNEW = NEW S TENSOR IN I FRAME      (SYMMETRICAL)
C     TROT = TRACE OF OLD T, TRNT = TRACE OF NEW T
C
C     ROL(3) = ORIGIN SHIFT IN L FRAME
C     SL = ORIG. S TENSOR IN L FRAME
C     TL = ORIG. T TENSOR IN L FRAME
C     TLE = EIGENVALUES OF TL, TTLEV= EIGENVECTORS OF TL
C     SO = NEW SYMMETRIC S TENSOR IN L FRAME
C     TO = NEW T TENSOR IN L FRAME, TRACE OF T REDUCED
C     TOE = EIGENVALUES OF TO, TOEV = EIGENVECTORS OF TO
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON//AIDX(3000)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2  IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig
      COMMON/INOUTN/ NPAGE, KOUTP, DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
C * * Make common IO assignments.
      COMMON/IOSET/LI,LO,LTB
      DIMENSION AAHT(3,3),AHS(3,3),AHL(3,3),VL(3,3),SL(3,3),TL(3,3)
      DIMENSION PT(6),ROL(3),RO(3),VLT(3,3),SO(3,3),TO(3,3),TNEW(3,3)
      DIMENSION TOE(3,3),TOEV(3,3),TLE(3,3),TLEV(3,3),TNEWE(3,3)
      DIMENSION TNEWV(3,3),AHT(3,3),VT(3,3),P(80)
      DIMENSION R(3,3),SNEW(3,3)
      DIMENSION AXX(150,3)
      EQUIVALENCE(AXX(1,1),AIDX(1))
      EQUIVALENCE (PT(1),AIDX(2631)),(VL(1,1),AIDX(2641))
      EQUIVALENCE (AHL(1,1),AIDX(2601)),(AHT(1,1),AIDX(2611))
      EQUIVALENCE (VT(1,1),AIDX(2651)), (P(1),AIDX(801))
      EQUIVALENCE(AAHT(1,1),AIDX(2771)),(AHS(1,1),AIDX(2781))
      EQUIVALENCE(SL(1,1),AIDX(2791)),(TL(1,1),AIDX(2801))
      EQUIVALENCE(ROL(1),AIDX(2811)),(RO(1),AIDX(2815))
      EQUIVALENCE(VLT(1,1),AIDX(2821)),(R(1,1),AIDX(761))
      EQUIVALENCE(SO(1,1),AIDX(2831)),(TO(1,1),AIDX(2841))
      EQUIVALENCE(TNEW(1,1),AIDX(2551)),(TOE(1,1),AIDX(2561))
      EQUIVALENCE (TOEV(1,1),AIDX(2571)),(TLE(1,1),AIDX(2581))
      EQUIVALENCE(TLEV(1,1),AIDX(2591)),(TNEWE(1,1),AIDX(601))
      EQUIVALENCE (TNEWV(1,1),AIDX(611)),(SNEW(1,1),AIDX(751))
      EQUIVALENCE (TROT,AIDX(695)),(TRNT,AIDX(696))
      CHARACTER*4 NAME1,ATNAME,TISET,TITLE*80, ITBL*3, NAME2*5
C
      CALL VMLT(PT,AAHT)
      CALL TRIPLE(VLT,AAHT,VL,TL)
      SL1 = SL(2,3) - SL(3,2)
      SL2 = SL(3,1) - SL(1,3)
      SL3 = SL(1,2)- SL(2,1)
      ROL(1) = SL1 /(AHL(2,2) + AHL(3,3))
      ROL(2) = SL2 /(AHL(1,1) + AHL(3,3))
      ROL(3) = SL3 /(AHL(1,1) + AHL(2,2))
      CALL MATVEC(VL,ROL,RO)
      DO 20 I = 1,3
      DO 20 J = 1,3
      R(I,J) = 0.
      DO 20 K = 1,3
      R(I,J) = R(I,J) + EPSIJK(I,J,K)*ROL(K)
   20 CONTINUE
C     CALCULATE NEW SYMMETRICAL S IN L FRAME
      DO 30 I = 1,3
      DO 30 J = 1,3
      SO(I,J) = R(J,I)*AHL(I,I) + SL(I,J)
   30 CONTINUE
C     CALCULATE NEW T IN L FRAME
      DO 40 I = 1,3
      DO 40 L = 1,3
      TO(I,L) = 0.
      DO 50 J = 1,3
      TO(I,L) = TO(I,L) + R(I,J)*R(L,J)*AHL(J,J)
      TO(I,L) = TO(I,L) + R(I,J)* SL(J,L) + R(L,J)*SL(J,I)
   50 CONTINUE
      TO(I,L) = TO(I,L) + TL(I,L)
   40 CONTINUE
      CALL TRIPLE(VL,TO,VLT,TNEW)
      CALL TRIPLE(VL,SO,VLT,SNEW)
      DO 60 I = 1,3
      DO 60 K = 1,3
      TOE(I,K) = TO(I,K)
      TLE(I,K) = TL(I,K)
      TNEWE(I,K) = TNEW(I,K)
   60 CONTINUE
      CALL EIGEN(TOE,TOEV,3)
      CALL EIGEN(TLE,TLEV,3)
      CALL EIGEN(TNEWE,TNEWV,3)
      TROT = 0.
      KOUTP = 1
      DO 70 I = 1,3
      TROT = TROT + AAHT(I,I)
   70 CONTINUE
      TRNT = TROT - ROL(1)*SL1 - ROL(2)*SL2 - ROL(3)*SL3
      IF(NS.LT.0) RETURN
      CALL OUTH6
      CALL OTHR12
      CALL OUTR7
C     PRINT ORIGIN SHIFT AND TENSORS IN L AND I FRAME
      RETURN
      END
