      SUBROUTINE NRCOR(NCOR)
C  LATEST MODIFICATION, OCTOBER 1985
C  MODIFIED APRIL 1984 FOR NORMAL-MODE CALCULATION FOR OVERALL MOLECULAR
C    MOTION (NCOR = 1)
C
C  FORMERLY USED FOR CALCULATING CORRECTIONS TO BOND DISTANCES AFFECTED
C    BY MOTION OF ATTACHED RIGID GROUPS; THIS NOW DONE IN DISCOR (OCT85)
C     STILL USED FOR CALCULATION OF HARMONIC FREQUENCIES AND FORCE
C    CONSTANTS FOR BOTH INTERNAL ('NON-RIGID') AND OVERALL MOTION
C  CLASSICAL FREQUENCY USED AS FIRST APPROX TO QM FREQ, AND ITERATION
C    CONTINUED UNTIL RATIO OF FREQUENCIES IN TWO SUCCESSIVE CYCLES
C    IS BETWEEN 0.999 AND 1.001, I.E., SAME WITHIN 0.1 PERCENT.
C    IF NO. OF CYCLES REQUIRED EXCEEDS 20, IT STOPS AT 20.
C    ITERATION RECIPE DEPENDS ON VALUE OF ARG OF TANH.  SEE BETWEEN
C      145 AND 148.
C    NOTE THAT THE MOMENT OF INERTIA IS USED IN CALCULATING THE FRE-
C      QUENCY AND FOR X-RAY STRUCTURES, WITH H-ATOMS OMITTED, THE
C      MOMENT OF INERTIA WILL BE LOW (E.G., FOR A METHYL GROUP,
C      REPRESENTED BY A C RATHER THAN A CH3.  THE DIFFERENCE IS OF
C      THE ORDER OF 20 TO 25 % FOR A METHYL (OR T-BUTYL), WHICH CAN
C      MAKE THEN A DIFFERENCE OF AROUND 10 % IN THE FREQUENCY.  THE
C      FORCE CONSTANT AND THE BARRIER CALCULATIONS WILL NOT BE AF-
C      FECTED, IN THE CLASSICAL APPROXIMATION (WHICH IS VALID FOR
C      MOST GROUPS WITH AT WTS OF 15 OR MORE UNLESS THE TEMPERATURE
C      IS VERY LOW), BECAUSE THE MOMENT OF INERTIA THEN CANCELS OUT.
C      (CLASSICALLY, THE FORCE CONSTANT IS JUST KT/(MEAN SQ AMP).)
C
C  NCOR = 0, CALCS FOR INTERNAL MOTION (CALLED ONLY IF NONRIG.NE.0)
C  NCOR = 1, CALCS FOR OVERALL MOTION
C
      COMMON// AIDX(3000)
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/AXESN/ISPAX(15),LT(5,15),LAT(5,15)
      COMMON/AXESC/LBAT(5,15)
      CHARACTER*4 LBAT
      COMMON/CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,
     1  NTOT,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
      COMMON/LOC/ VAF(7,3), PVEC(7,3),V5(7,3), VEC1(15,3)
      COMMON/LOCC/ ATNX(7,2), BLLARG(7)
C * * Make common IO assignments.
      COMMON/IOSET/LI,LO,LTB
C
      DIMENSION P(80),SIGP(80),NAT(15,150),NRBP(150),WTT(150)
      DIMENSION MAT(40),IZ(5),DEL(3),VEC(3),VC(3),SG(15)
      DIMENSION AMP(15),AMOM(15),FRCL(15),FRQ2(15),IGR(15),NCY(15)
      DIMENSION  FRU(15),FUJ(15),CORD(40),B2(15),FDEGJ(15),AXMOM(15)
      DIMENSION  EIGI(3),PL(6),AP(3),NAFA(15),NONSY(15),B3(15),B6(15)
      DIMENSION AHL(3,3),SQMI(3),KGO(3,3),BB(6,6),VB(6,6),AHT(3,3)
C
      EQUIVALENCE (EIGI(1),AIDX(798)), (PL(1),AIDX(2621))
C ***  EIGI(J) ARE PRINCIPAL MOMENTS OF INERTIA OF MOL (SEE SUBR INERT,
C ***        LINES 12220 AND 13185-13195)
      EQUIVALENCE  (P(1),AIDX(801))
      EQUIVALENCE (NRBP(1),IAIDX1(850)), (NAFA(1),IAIDX1(766))
      EQUIVALENCE (AXMOM(1),AIDX(1121))
      EQUIVALENCE (SIGP(1), AIDX(881)), (WTT(1), AIDX(451))
      EQUIVALENCE (TK,AIDX(797)),(NONSY(1),IAIDX1(601))
      EQUIVALENCE (AHL(1,1),AIDX(2601)),(AHT(1,1),AIDX(2611))
C ***  WHEN NRCOR CALLED FROM ATINT, AHL AND AHT ARE EIGENVALUES L,T
C
      CHARACTER*4 ATNX, NAME1,ATNAME,TISET,TITLE*80, ITBL*3, NAME2*5
C
  900 FORMAT(1H ,I4,' ATOMS INPUT IN NR GROUP',I4,' BUT ONLY',
     1 ' FOUND NOW')
  901 FORMAT(1H )
  902 FORMAT(2X,I2,T14,A4,T22,A4,T31,F6.3,T38,F5.3,T48,F6.3)
C 903 FORMAT(1H ,'INTERNAL MOTION CORRECTIONS TO INTERATOMIC DISTANCES I
C    1N NON-RIGID GROUPS WITH POSITIVE LIBRATION AMPLITUDES',/3X,
C    2'THESE CORRECTIONS DO NOT INCLUDE EFFECTS OF OVERALL MOLECULAR LIB
C    3RATION',//T31,'UNCORR',T46,'CORRECTED',/T2,'GROUP',T13,'ATOM 1',
C    4 T21,'ATOM 2',T32,'DIST',T39,'CORR',T46,'DISTANCE',/)
  904 FORMAT(1H ,'ATOM ',A4,' OF NON-RIGID GROUP ',I2,' IS AT SAME POSIT
     1ION AS ATOM ',A4,' USED TO DEFINE AXIS OF THE GROUP',/4X,
     2 'THIS ATOM SKIPPED IN THE CALCULATIONS.')
  905 FORMAT(1H ,'TEMPERATURE INPUT AS ZERO. CHANGED TO 296 K HERE')
  906 FORMAT(1H ,'CONVERGENCE TOOK MORE THAN 20 ITERATIONS FOR GROUP',
     1 I3,'.  STOPPED ITERATING AFTER 20 CYCLES')
  907 FORMAT(1H ,T12,'MEAN SQUARE',T27,'CORRD MOMENT',T70,'Q.M.',T82,
     1 'FORCE CONSTANT',T102,'COSINE FUNCTION',/T12,'AMPL    ESD',T28,
     2 'OF INERTIA',T42,'(CLASSICAL)',T68,'FREQUENCY',T84,
     X 'JOULE/MOL',T101,'BARRIER  (KJ/MOL)',/T2,'AXIS',
     3 T11,'(DEGREES SQ)',T26,'(AT WT, ANGST)',T42,'(FREQUENCY)',T57,
     4 '(ITER)',T67,'(RECIPR CM)',T82,'PER SQ. DEGREE',T101,
     5  'N=2    N=3    N=6',/)
  908 FORMAT(2X,I2,T10,F6.1,T16,'(',T17,F6.1,T23,')',T28,F7.1,T44,F6.1,
     1 T56,I5,T66,F6.1,T72,'(',T73,F5.1,T78,')',T81,F7.1,T88,'(',
     2 T89,F6.1,T95,')',T98,2F7.1,T112,F7.2)
  909 FORMAT(//,1X,'HARMONIC FREQUENCIES AND FORCE CONSTANTS FOR INTERNA
     1L MOTION.  GROUPS WITH NEGATIVE MEAN SQUARE AMPLITUDE SKIPPED',/)
  910 FORMAT(1H ,'HARMONIC FREQUENCIES AND FORCE CONSTANTS FOR OVERALL M
     1OLECULAR LIBRATION',/)
  911 FORMAT(2X,I2,T10,F6.1,T27,F8.1,T44,F6.1,T58,I3,T68,F6.1,T83,
     1  F8.1)
  912 FORMAT(/,9X,'NO FREQUENCY CALCULATIONS DONE FOR NON-RIGID GROUPS
     1 THAT LIE ON SYMMETRY ELEMENTS, UNLESS AXMOM(I) INPUT.'/10x,'IF
     2 THE SYMMETRY IS HIGHER THAN P1 OR P1-BAR (NO.GE.3) AND IF NONSY
     3 INPUT AS ZERO FOR ANY ARG,'/10X,'PROGRAM ASSUMES THAT THAT ARG
     4 LIES ON A SYMMETRY ELEMENT',/)
  913 FORMAT(1H ,5X,'(UNCERTAINTY IN Q.M. FREQUENCY ESTIMATED BY REDOING
     1 CALCULATION FOR SUM OF MEAN SQ AMPLITUDE AND ITS ESD)')
  914 FORMAT(1H ,'FREQUENCY VALUES CALCULATED HERE SHOULD BE TAKEN "CUM
     1 GRANO SALIS"'/)
  990 FORMAT(1H ,'VECTOR LENGTH ZERO BETWEEN ',A4,' AND ',A4,
     1 ' IN NON-RIGID GROUP',I3,'. CALCULATION TERMINATED.')
  991 FORMAT(1H ,'MOMENT OF INERTIA NOT CORRECTED FOR THESE CALCULATIONS
     1 ')
  992 FORMAT(1H ,'NO FREQUENCY CALCS FOR GROUP',I2,' BECAUSE MOMENT OF I
     1NERTIA IS ZERO.  ARE ATOMIC WTS OK FOR ATOMS IN THIS GROUP?')
C
      C1 = 3282.81
C   C1 IS (180/PI) SQUARED
      C2 = 4.8405
C   C2 IS (10 TO 8TH)*SQRT(R)/(2*PI*C), WITH R IN ERGS/MOL-K,
C     AND C IN CM/SEC
      C3 = 16.86
C   C3 IS ((PLANCK'S CONSTANT)*(N AVOG)*(10 TO 16TH))/(8*PISQ*C)
      C4 = 0.7194
C   C4 IS ((PLANCK'S CONSTANT)*C)/(2*(BOLTZMANN'S CONSTANT))
      C5 = 0.3548
C   C5 IS 4*PISQ*(C SQ)*(10 TO -23RD), FOR GETTING FORCE CONSTANTS
C     IN JOULE/(MOL RADSQ) FROM FREQ IN RECIP CM
C   C6 IS CONVERSION FACTOR FOR NO. OF CALORIES TO NO. OF JOULES
      C6 = 4.184
      NR = NONRIG
      IF(NCOR.EQ.0) GO TO 10
      IF(NCOR.EQ.1) GO TO 500
      RETURN
   10 DO 12 I = 1,15
      DO 12 J = 1,150
      NAT(I,J) = 0
   12 CONTINUE
      DO 40 K = 1,NA
      IF(NRBP(K).EQ.0) GO TO 40
      J1 = 0
      N = NRBP(K)
      DO 15 J = 1,5
      IH = N/16
      IZ(J) = N - 16*IH
      IF(IZ(J).EQ.0) GO TO 20
      N = IH
      J1 = J1 + 1
   15 CONTINUE
C  J1 IS THE NUMBER OF N.R. GROUPS ATOM K IS IN
C  NRBP(K) IS BUILT UP CODE NUMBER TELLING WHICH NR GROUPS K IS IN
C  IZ(J), WITH J.NE.0, ARE SERIAL NOS OF NR GROUPS ATOM K IS IN,
C    WITH J VARYING FROM 1 TO J1 FOR THAT ATOM
   20 DO 30 I = 1,NR
      DO 30 J = 1,J1
      IF(I.EQ.IZ(J)) NAT(I,K) = 1
   30 CONTINUE
   40 CONTINUE
C   NOW NAT(I,K) CONTAINS 1 FOR EVERY NR GROUP I THAT CONTAINS
C    ATOM K.  NOW DO CALCULATION FOR EACH NR GROUP IN TURN
C
C ****  FOLLOWING SECTION COMMENTED OUT, OCT 85; DISCOR NOW DOES IT
C
C     CALL OUTH6
C     WRITE(LO,903)
C     NT = 1
C   NT IS TALLY OF LINES WRITTEN (FOR PAGINATION)
      DO 200 I = 1,NR
C     WRITE(LO,901)
      KK = I + NP1
      IF(P(KK).LE.0.0) GO TO 200
C  NO CALCULATIONS WHEN LIBR AMPL FOR NON-RIG GROUP IS NEG OR ZERO
      AMOM(I) = 0.0
      N = NAFA(I)
      M = 0
      DO 50 J = 1,NA
      IF(NAT(I,J).EQ.0) GO TO 50
      M = M + 1
      MAT(M) = J
C  MAT(M) STORES ATOM NUMBERS OF THE ATOMS IN RIGID GROUP I
C   M TALLIES THE NUMBER OF (UNIQUE) ATOMS IN THE GROUP
   50 CONTINUE
      IF(M.NE.N) WRITE(LO,900) N,I,M
      NN = M + 1
      MAT(NN) = LT(2,I)
      IF(ISPAX(I).NE.0) MAT(NN) = LT(5,I)
C  INCLUDE SECOND ATOM DEFINING AXIS IN LIST FOR DISTANCES
      DO 100 J = 1,N
      KL = J + 1
      DO 100 K = KL,NN
      L = MAT(J)
      LN = MAT(K)
      XL = 0.0
      DO 60 II = 1,3
      DEL(II) = AX(L,II) - AX(LN,II)
      XL = XL + DEL(II)*DEL(II)
   60 CONTINUE
      XL = SQRT(XL)
      IF(XL.NE.0.0) GO TO 62
C  VECTOR OF LENGTH 0.0 BETWEEN TWO ATOMS IN NON-RIGID GROUP
      WRITE(LO,990) ATNAME(L),ATNAME(LN),I
      CALL EXIT
   62 DO 65 II = 1,3
      VEC(II) = DEL(II)/XL
   65 CONTINUE
      VC(1) = VEC1(I,2)*VEC(3) - VEC1(I,3)*VEC(2)
      VC(2) = VEC1(I,3)*VEC(1) - VEC1(I,1)*VEC(3)
      VC(3) = VEC1(I,1)*VEC(2) - VEC1(I,2)*VEC(1)
      SVC = 0.0
      DO 70 II = 1,3
      SVC = SVC + VC(II)*VC(II)
   70 CONTINUE
C   SVC IS SQUARE OF SINE OF ANGLE BETWEEN VECTOR FROM ATOM L
C    TO ATOM LN AND THE AXIS OF THE NON-RIGID GROUP
      COR = 0.5*XL*SVC*P(KK)
      XLC = XL + COR
      IF(K.EQ.NN)  CORD(J) = XLC
C  SAVE CORRD DIST TO LAST ATOM (ATOM ON AXIS) FOR USE IN CALC
C     CORRECTED MOMENT OF INERTIA FOR THIS GROUP LATER
C
C ****  FOLLOWING LINES COMMENTED OUT OCT 85
C
C     WRITE(LO,902) I,ATNAME(L),ATNAME(LN),XL,COR,XLC
C     NT = NT + 1
C     IF(NT.LE.50) GO TO 100
C     NT = 1
C     CALL OUTH6
C     WRITE(LO,903)
  100 CONTINUE
C   FOLLOWING IS FOR CALCULATING FREQUENCY AND FORCE CONSTANTS.  SKIP IF
C      NR GROUP LIES ON SYM ELEMENT BECAUSE OF DIFFICULTY IN GETTING
C      MOMENT OF INERTIA FOR SUCH NR GROUPS, UNLESS MOM OF INERTIA INPUT
      IF(NO.GT.2.AND.NONSY(I).EQ.0.AND.AXMOM(I).EQ.0) GO TO 200
C   N IS THE NUMBER OF AFFECTED ATOMS IN EACH GROUP (NAFA(I))
  110 DO 140 J = 1,N
      L = MAT(J)
      LN = LT(2,I)
      XL = 0.0
      DO 115 II = 1,3
      DEL(II) = AX(L,II) - AX(LN,II)
      XL = XL + DEL(II)*DEL(II)
  115 CONTINUE
      XL = SQRT(XL)
      IF(XL.NE.0.0) GO TO 120
      WRITE(LO,904) ATNAME(L),I,ATNAME(LN)
      GO TO 140
  120 DO 125 II = 1,3
      VEC(II) = DEL(II)/XL
  125 CONTINUE
      VC(1) = VEC(2)*VEC1(I,3) - VEC(3)*VEC1(I,2)
      VC(2) = VEC(3)*VEC1(I,1) - VEC(1)*VEC1(I,3)
      VC(3) = VEC(1)*VEC1(I,2) - VEC(2)*VEC1(I,1)
      SVC = 0.0
      DO 130 II = 1,3
      SVC = SVC + VC(II)*VC(II)
  130 CONTINUE
      SVC = SQRT(SVC)
C  NOW SVC = SINE OF ANGLE FROM AXIS TO THE VECTOR FROM THE SECOND
C       ATOM DEFINING THE AXIS TO ATOM L
C    CORD(J) = DISTANCE FROM SECOND ATOM DEFINING AXIS TO ATOM L
C    DDIS = CORRD DISTANCE OF ATOM L FROM THE AXIS
      DDIS = CORD(J)*SVC
      AMOM(I) = AMOM(I) + WTT(L)*DDIS*DDIS
C  AMOM(I) WILL BE THE MOMENT OF INERTIA IN AT WT UNITS & SQ ANGSTR
C      (INCLUDING CORRD DISTANCES, SIGNIFICANT FOR LARGE AMPLITUDES)
  140 CONTINUE
      IF(NO.GT.2.AND.AXMOM(I).NE.0) AMOM(I) = AXMOM(I)
C *** IF AMOM(I) = 0. (BECAUSE ATWTS ARE 0.0, E.G.), PRINT MESSAGE
C ***    AND SKIP THIS GROUP
      IF(AMOM(I).NE.0.) GO TO 141
      WRITE(LO,992) I
      GO TO 200
  141 CON1 = C4/TK
      CON2 = C3/(AMOM(I)*P(KK))
      AMP(I) = C1*P(KK)
      SG(I) = C1*SIGP(KK)
C   THESE QUANTITIES ARE NOW IN DEGREES SQUARED
      FRCL(I) = C2*SQRT(TK/(AMOM(I)*P(KK)))
C   USE CLASSICAL FREQUENCY AS FIRST APPROX TO QM FREQ
      FRQ1 = FRCL(I)
      IF(TK.NE.0.0) GO TO 142
      WRITE(LO,905)
      TK = 296.0
C  FRQ1 CANNOT BE 0.0 UNLESS TK INPUT AS ZERO, AND THUS TANH
C    CAN'T BE ZERO, SO CAN USE COTH = 1.0/TANH
  142 T1 = TANH(CON1*FRQ1)
      FRQ2(I) = CON2/T1
      NCY(I) = 1
      FRQ1 = FRQ2(I)
  145 T1 = TANH(CON1*FRQ1)
      FRQ2(I) = CON2/T1
      NCY(I) = NCY(I) + 1
      RAT = FRQ2(I)/FRQ1
      CONV = ABS(1.0 - RAT)
      IF(CONV.LT.0.001) GO TO 150
      IF(T1.LT.0.75) GO TO 148
C   FASTER CONVERGENCE BY AVERAGING WHEN T1 LESS THAN 0.75
      FRQ1 = FRQ2(I)
      IF(NCY(I).LT.20) GO TO 145
      WRITE(LO,906) I
      GO TO 150
  148 FRQ1 = 0.5*(FRQ1 + FRQ2(I))
      IF(NCY(I).LT.20) GO TO 145
      WRITE(LO,906) I
C  NOW ESTIMATE UNCERTAINTY IN THE FREQUENCY FROM SIGMA AMPL
  150 A2 = P(KK) + SIGP(KK)
      FCL = C2*SQRT(TK/(AMOM(I)*A2))
      F1 = FCL
      CON3 = C3/(AMOM(I)*A2)
      T2 = TANH(CON1*F1)
      FREQ = CON3/T2
      NCY2 = 1
      F1 = FREQ
  155 T2 = TANH(CON1*F1)
      FREQ = CON3/T2
      NCY2 = NCY2 + 1
      RAT = FREQ/F1
      CONV = ABS(1.0 - RAT)
      IF(CONV.LT.0.001) GO TO 160
      IF(T2.LT.0.75) GO TO 158
      F1 = FREQ
      IF(NCY2.LT.20) GO TO 155
      GO TO 160
  158 F1 = 0.5*(F1 + FREQ)
      IF(NCY2.LT.20) GO TO 155
  160 FRU(I) = ABS(FRQ2(I) - FREQ)
      FDEGJ(I) = (C5/C1)*AMOM(I)*FRQ2(I)*FRQ2(I)
      FOR2 =(C5/C1)*AMOM(I)*FREQ*FREQ
      FUJ(I) = ABS(FDEGJ(I) - FOR2)
      TEMP = C1*0.001*FDEGJ(I)
C  TEMP IS NOW F IN KJ PER SQ RADIAN PER MOL
      B2(I) = TEMP/2.0
      B3(I) = TEMP/4.5
      B6(I) = TEMP/18.0
C  B2,B3,B6 ARE CORRESPONDING BARRIERS FOR 2-FOLD, 3-FOLD AND
C     6-FOLD COSINE POTENTIALS
  200 CONTINUE
C ***  print no headings unless calculations made for at least one arg
      iall = 0
      do 205 i = 1,nr
      IF(NO.GT.2.AND.NONSY(I).EQ.0.AND.AXMOM(I).EQ.0.) GO TO 205
      iall = 1
  205 continue
      if(iall.eq.0) go to 220
      WRITE(LO,909)
      WRITE(LO,914)
      WRITE(LO,907)
      DO 210 I = 1,NR
      KK = NP1 + I
      IF(P(KK).LE.0.0) GO TO 210
      IF(NO.GT.2.AND.NONSY(I).EQ.0.AND.AXMOM(I).EQ.0.) GO TO 210
C  NOTHING TO PRINT IF GROUP LIES ON SYM ELEMENT AND NO MOM OF INERTIA
C     WAS INPUT, OR IF MOM OF INERTIA IS ZERO
      IF(AMOM(I).EQ.0.0.AND.AXMOM(I).EQ.0.) GO TO 210
      WRITE(LO,908,ERR=210)I,AMP(I),SG(I),AMOM(I),FRCL(I),NCY(I),FRQ2(I)
     &,FRU(I),FDEGJ(I),FUJ(I),B2(I),B3(I),B6(I)
  210 CONTINUE
      WRITE(LO,913)
  220 IF(NO.GT.2) WRITE(LO,912)
      RETURN
C  FOLLOWING IS FOR LIBRATIONAL FREQUENCIES FOR OVERALL MOTION
C *** LINES 17986:18050 WERE USED IN VERSIONS BEFORE APRIL 1984
C 500 CALL OUTH6
  499 WRITE(LO,910)
      WRITE(LO,914)
      WRITE(LO,907)
      AP(1) = PL(1)
      AP(2) = PL(4)
      AP(3) = PL(6)
      DO 600 I = 1,3
      IF(AP(I).LE.0) GO TO 600
      AMP(I) = C1*AP(I)
      FRCL(I) = C2*SQRT(TK/(EIGI(I)*AP(I)))
      NCY(I) = 0
      FRQ1 = FRCL(I)
      IF(TK.NE.0.0) GO TO 510
      WRITE(LO,905)
      TK = 296.0
  510 T1 = TANH(C4*FRQ1/TK)
      FRQ2(I) = C3/(EIGI(I)*AP(I)*T1)
      NCY(I) = NCY(I) + 1
      RAT = FRQ2(I)/FRQ1
      CONV = ABS(1.0 - RAT)
      IF(CONV.LT.0.001) GO TO 520
      IF(T1.LT.0.75) GO TO 515
      FRQ1 = FRQ2(I)
      IF(NCY(I).LT.20) GO TO 510
      GO TO 520
  515 FRQ1 = 0.5*(FRQ2(I) + FRQ1)
      IF(NCY(I).LT.20) GO TO 510
  520 FDEGJ(I) = (C5/C1)*EIGI(I)*FRQ2(I)*FRQ2(I)
      WRITE(LO,911) I,AMP(I),EIGI(I),FRCL(I),NCY(I),FRQ2(I),FDEGJ(I)
  600 CONTINUE
      WRITE(LO,991)
C *** REMAINDER OF PROGRAM IS NEW, APRIL 1984
  500 CALL OUTH6
      IF(NCOR.GT.1) GO TO 499
C ***  PRECEDING ONLY TO PROVIDE DUMMY PATH TO OLDER PART OF PROGRAM
      DO 700 I = 1,3
C ***  SQMI(J) SQ RTS OF PRINCIPAL MOMENTS OF INERTIA
  700 SQMI(I) = SQRT(EIGI(I))
C ***   SQM WILL BE SQRT OF MOL WT
      SQM = SQRT(SUMW)
      DO 710 I = 1,6
      DO 710 J = 1,6
  710 BB(I,J) = 0.
C ***  SET UP 6X6 MATRIX:      T    S-TRANSPOSE
C ***                          S    L
C ***    (NOTE THAT OUR DEFN OF S AS AVE OF (ROT-TRANSL) IS OPPOSITE TO
C ***      THAT OF WILLIS & PRYOR)
      BB(1,1) = P(7)*SUMW
      BB(1,2) = P(8)*SUMW
      BB(1,3) = P(9)*SUMW
      BB(2,2) = P(10)*SUMW
      BB(2,3) = P(11)*SUMW
      BB(3,3) = P(12)*SUMW
      BB(4,4) = P(1)*EIGI(1)
      BB(4,5) = P(2)*(SQMI(1)*SQMI(2))
      BB(4,6) = P(3)*(SQMI(1)*SQMI(3))
      BB(5,5) = P(4)*EIGI(2)
      BB(5,6) = P(5)*(SQMI(2)*SQMI(3))
      BB(6,6) = P(6)*EIGI(3)
      IF(NPARS.EQ.0) GO TO 720
C ***   WHEN NPARS = 0, THERE ARE NO INDEP COMPONENTS OF THE S TENSOR
      BB(1,4) = P(13)*(SQM*SQMI(1))
      BB(1,5) = P(16)*(SQM*SQMI(2))
      BB(1,6) = P(19)*(SQM*SQMI(3))
      BB(2,4) = P(14)*(SQM*SQMI(1))
      BB(2,5) = P(17)*(SQM*SQMI(2))
      BB(2,6) = P(20)*(SQM*SQMI(3))
      BB(3,4) = P(15)*(SQM*SQMI(1))
      BB(3,5) = P(18)*(SQM*SQMI(2))
      BB(3,6) = P(21)*(SQM*SQMI(3))
  720 ISKIP = 0
C ***  TEST FOR NEGATIVE DIAGONAL ELEMENTS IN BB(I,J); SKIP CALC IF ANY
      DO 780 I = 1,6
      IF(BB(I,I).LT.0.) GO TO 755
      GO TO 780
  755 GO TO (760,760,760,765,765,765) I
  760 WRITE(LO,785) I, BB(I,I)
  785 FORMAT(1H ,'DIAGONAL ELEMENT',I2,' OF T IS NEGATIVE, ',F12.6,';
     1    NO NORMAL MODE CALCULATION')
      ISKIP = 1
      GO TO 780
  765 J = I-3
      WRITE(LO,788) J, BB(I,I)
  788 FORMAT(1H ,'DIAGONAL ELEMENT',I2,' OF L IS NEGATIVE, ',F12.7,';
     1    NO NORMAL MODE CALCULATION')
      ISKIP = 1
  780 CONTINUE
      IF(ISKIP.NE.0) RETURN
      DO 725 I = 1,6
      K = I + 1
      DO 725 J = K,6
  725 BB(J,I) = BB(I,J)
C     WRITE(LO,800) ((BB(I,J), I = 1,6), J = 1,6)
C ***  WRITE OUT EIGENVALUE MATRIX ON UNIT 9 FOR CHECKING
C     WRITE(9)  ((BB(I,J), I = 1,6), J = 1,6)
      CALL EIGEN(BB,VB,6)
C ***  EIGEN (WITH N = 6) CALCULATES EIGENVALUES, VECTORS FOR MATRIX BB
C ***    THE EIGENVALUES WILL BE BB(1,1), BB(2,2), ... WHEN RETURNED,
C ***    AND THE EIGENVECTOR FOR EIGENVALUE BB(I,I) WILL BE IN COLUMN I
C ***    OF THE MATRIX OF VECTORS, VB(J,I)
C ***  THE EIGENVALUES ARE FORCE CONSTANTS, AND TO THE EXTENT THAT THE
C ***    CLASSICAL APPROX IS VALID CAN BE CONVERTED TO FREQUENCIES IN
C ***    THE USUAL WAY
  800 FORMAT(1H , 'MATRIX FOR NORMAL MODE CALCULATION',/6(5X,6F20.10/))
C     WRITE(LO,810) ((BB(I,J), I = 1,6), J = 1,6)
  810 FORMAT(1H , 'NORMAL MODE MATRIX',/6(5X,6F20.10,/))
C ***  EIGENVECTORS ARE ARRANGED IN COLS (COL I HAS VECTOR FOR MODE I)
      WRITE(LO,820) (I, BB(I,I), (VB(J,I), J = 1,6 ), I = 1,6)
  820 FORMAT(1H ,'NORMAL MODES:             CALCULATED FROM MASS-WEIGHTE
     1D, I-WEIGHTED 6X6 MATRIX DERIVED FROM --->:',7X,'T   S-transpose'/
     217X,'NOTE: S HERE IS AVE OF (ROT*TRANSL); WILLIS & PRYOR [p. 178,
     3 eq. (6c)] USE              S   L   '/
     420X,'OPPOSITE CONVENTION, AVE OF (TRANSL*ROT), SO THEIR S(J,I)
     5 IS OUR S(I,J)'/17X,'T,L,S REFERRED TO INERTIAL AXES IN THIS CALCU
     6LATION'        /11X,'UNITS OF EIGENVALUES ARE (AMU)*(ANGSTROM SQUA
     7RED)'//1X,'MODE',5X,'EIGENVALUE',20X,'EIGENVECTOR -->'/
     8  6(1X,I3,3X,F11.4,20X,6F12.5,/)/)
      DO 740 I = 1,6
      IF(BB(I,I).GT.0) GO TO 735
      FRCL(I) = 0.0
      GO TO 740
  915 FORMAT(1H ,10X,  'IF EIGENVALUE WAS ZERO OR NEGATIVE, FREQUENCY PR
     1INTED AS 0.0')
  735 FRCL(I) = C2*SQRT(TK/BB(I,I))
  740 CONTINUE
      WRITE(LO,914)
      WRITE(LO,915)
      WRITE(LO,830) (FRCL(I), I = 1,6)
  830 FORMAT(1H ,'NORMAL-MODE FREQUENCIES, ASSUMING THAT OBSERVED T,L,S
     1 REFLECT POTENTIAL FUNCTION AROUND THE MOLECULE'/10X,'UNITS ARE RE
     2CIPROCAL CM:', 6F12.1,/)
      RETURN
      END
