      SUBROUTINE SGTRAN(A,B,BB,NTOS,MM)
C ***  SIGNIF CHANGES, 17-20.IV.87
C   ADDED JANUARY 1982 TO TRANSFORM VARIANCE-COVARIANCE TENSOR OF THE
C     U'S, FROM CRYSTAL SYSTEM TO ORTHOGONAL SYSTEM WHEN CALLED FROM
C     INERT.  FIRST, CALCULATES ESD'S FOR SYMMETRY-EQUIVALENT ATOMS
C     WITHIN CRYSTAL SYSTEM WHEN CALLED FROM SYMPOS.  ALL CORRELATION
C     BETWEEN U(I,J) OF THE SAME OR DIFFERENT ATOMS IS IGNORED,
C     EXCEPT THAT ARISING FROM THE OBLIQUITY OF THE AXES OF THE CRYSTAL
C     SYSTEM.  THE PRESENT METHOD ASSUMES INTRINSIC COVARIANCE IS ISO-
C     TROPIC AND SAME FOR EVERY ATOM; TO TAKE INTO ACCOUNT CORRELATION
C     COEFFICIENTS IN THE LEAST SQUARES WOULD NECESSITATE INTRODUCING THE
C     ENTIRE COVARIANCE MATRIX FROM THE LEAST-SQUARES REFINEMENT OF THE
C     INDIVIDUAL ATOMS AND CONSIDERING EACH ATOM INDIVIDUALLY.  BASED ON
C     HIRSHFELD & SHMUELI, ACTA CRYST A28, 649-653 (1972)
C
C     A IS A 3X3 TRANSFORMATION MATRIX, USED AS A PRE-FACTOR (OMA FROM
C         INERT, TUS FROM SYMPOS)
C     B IS SIGB(150,6), THE COLUMN VECTOR FOR EACH ATOM'S INPUT SIG'S
C        INITIALLY;  AFTER SYMPOS (BEFORE NPAR AND INERT ARE CALLED),
C        WHEN NO.GE.1, SIGB ALSO INCLUDES ESD'S FOR SYM-EQUIV ATOMS
C     BB THE TRANSFORMED ESD'S OF U ARE PLACED IN BB AND RETURNED THUS
C       AS SIGU(K,I), WHERE K IS ATOM NUMBER AND I VARIES FROM 1 TO 6
C     NTOS IS CURRENT VALUE OF NTOTS (WHICH CHANGES DURING SYMPOS)
C     MM IS PATH-INDICATOR: 1 WHEN CALLED FROM INERT, EQ POSN NO (2 OR
C         MORE) WHEN CALLED FROM SYMPOS
C
      COMMON//AIDX(3000)
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
C * * Make common IO assignments.
      COMMON/IOSET/LI,LO,LTB
      EQUIVALENCE (ETA,AIDX(1201))
C
C
      DIMENSION A(3,3),B(150,6),V(3,3,3,3),TV(3,3,3,3),BB(150,6),
     1   VAR(9),VV(9),VX(9),VY(5),SU(3,3),ESD(9)
C
      CHARACTER*4 NAME1,ATNAME,TISET,TITLE*80, ITBL*3, NAME2*5
C
      NSIG=IABS(ISIG)
      X = ETA
      IF(MM.GT.1) GO TO 10
C       WHEN MM = 1, ENTER FROM INERT
      KA = 1
      KB = NSIG
      NTS = 0
C       NTS IS A TALLY USED ONLY WHEN MM.GT.1, BUT IT IS ALTERED IN THE
C       MAIN BRANCH (AFTER 15 BELOW) SO PRESET NOW FOR SAFETY
      LN = 1
      NN = 0
C       LN INDICATES EQUIVALENT POSITION, NN IS TALLY FOR ATOM NAMES
      KEQ = NSIG
      GO TO 15
C      WHEN MM.GT.1, ENTER FROM SYMPOS AT MMth EQUIV POSN
   10 KA = 1
      KB = NA
      LN = MM
      NN = 0
      NTS = NTOS - NA
C      WHEN ENTER FROM SYMPOS, TALLY ATOM NUMBER WITH NTS, WHICH
C      STARTS AT NTOT (INCREASED BY 1 BEFORE STORING NEW VALUES)
C      FOR FIRST SYM-EQUIV POSN AND IS CHANGED AFTER NA ATOMS,
C       AS IN SYMPOS
      KEQ = NA
C      LN AND NN ARE NOT PRESENTLY NEEDED WHEN ENTER FROM SYMPOS SINCE
C       THEY ARE ONLY USED IN PRINTING POSITIONS, AND THAT IS NOT NOW
C       DONE IN THIS BRANCH.
   15 DO 100  KK = KA,KB
      CALL VEMA(B,SU,KK)
      NTS = NTS + 1
      NN = NN + 1
C *** FORMERLY AVERAGED ESD'S; NOW (21.IV.87), AVERAGE VARIANCE
      VAR(4) = 0.0
      DO 20 I = 1,3
      VAR(I) = SU(I,I)*SU(I,I)
      VAR(4) = VAR(4) + VAR(I)
   20 CONTINUE
      ZD = 0.
      VAR(4) = VAR(4)/3.0
      ESD(5) = SU(1,2)/SQRT(0.5*(1-X) +
     1          0.5*(1 + X)*RCD(9)*RCD(9))
      ESD(6) = SU(1,3)/SQRT(0.5*(1 - X) +
     1          0.5*(1 + X)*RCD(8)*RCD(8))
      ESD(7) = SU(2,3)/SQRT(0.5*(1 - X) +
     1          0.5*(1 + X)*RCD(7)*RCD(7))
      DO 22 I = 5,7
      VAR(I) = ESD(I)*ESD(I)
   22 IF(ESD(I).EQ.0.) ZD = ZD + 1.0
      IF(ZD.GT.2.5) GO TO 23
      VAR(8) = (VAR(5) + VAR(6) + VAR(7))/(3.0 - ZD)
      GO TO 24
   23 VAR(9) = VAR(4)
      GO TO 25
   24 VAR(9) = (1.0/(6.0 - ZD))*(3.0*VAR(4) + (3.0 - ZD)*VAR(8))
   25 DO 28 I = 1,9
      ESD(I) = SQRT(VAR(I))
   28 CONTINUE
      IF(MM.GT.1.OR.NS.LT.0) GO TO 27
C ***  DON'T PRINT TABLE OF AVE VARIANCE WHEN NS NEGATIVE, OR WHEN
C ***    ENTER FROM SYMPOS
      WRITE(LO,900) LN,ATNAME(NN),(ESD(I),I=1,9)
  900 FORMAT(1X,I3,4X,A4,7X,2(3(F7.5,4X),4X,F7.5,8X),F7.5)
C      NOW USE OVERALL AVERAGE VARIANCE, AS CALCULATED ABOVE BY THE
C      RECIPE OF HIRSHFELD & SHMUELI, ACTA CRYST A28, 649 (1972), IN
C      CALCULATION OF ASSUMED ISOTROPIC COVARIANCES (SAME SOURCE).
C        THIS IS DONE SEPARATELY FOR EACH ATOM
   27 CON = VAR(9)
      V(1,1,1,1) = VAR(1)
      V(2,2,2,2) = VAR(2)
      V(3,3,3,3) = VAR(3)
      V(1,2,1,2) = SU(1,2)*SU(1,2)
      V(1,3,1,3) = SU(1,3)*SU(1,3)
      V(2,3,2,3) = SU(2,3)*SU(2,3)
   30 VV(3) = V(1,2,1,2)
      VV(4) = V(1,3,1,3)
      VV(5) = V(2,3,2,3)
C *** NOW USE STANDARD ETA (NOT INPUT ETA, IF DIFFERENT)(21.IV.87)
      X = -0.25
      DO 35 L = 3,5
      LL = 12 - L
      VX(L) = CON*((1-X)*RCD(LL)*RCD(LL) + X)
      VY(L) = CON*RCD(LL)
   35 CONTINUE
      DO 40 I = 1,2
      II = I + 1
      DO 40 J = II,3
      JJ = I + J
      V(J,I,J,I) = VV(JJ)
      V(J,I,I,J) = VV(JJ)
      V(I,J,J,I) = VV(JJ)
      V(I,I,J,J) = VX(JJ)
      V(J,J,I,I) = VX(JJ)
      V(J,I,I,I) = VY(JJ)
      V(I,J,I,I) = VY(JJ)
      V(I,I,J,I) = VY(JJ)
      V(I,I,I,J) = VY(JJ)
      V(I,J,J,J) = VY(JJ)
      V(J,I,J,J) = VY(JJ)
      V(J,J,I,J) = VY(JJ)
      V(J,J,J,I) = VY(JJ)
   40 CONTINUE
      DO 45 L = 7,9
      M = L + 1
      IF(M.EQ.10) M = 7
      N = M + 1
      IF(N.EQ.10) N = 7
      VV(L)=CON*(0.5*(1-X)*RCD(L) + 0.5*(1+X)*RCD(M)*RCD(N))
      VX(L) = CON*(X*RCD(L) + (1-X)*RCD(M)*RCD(N))
   45 CONTINUE
      DO 50 I = 1,3
      J = I + 1
      IF(J.EQ.4) J = 1
      K = J + 1
      IF(K.EQ.4) K = 1
      L = 2*I + J + K
      V(I,I,J,K) = VX(L)
      V(I,I,K,J) = VX(L)
      V(J,K,I,I) = VX(L)
      V(K,J,I,I) = VX(L)
      V(I,J,I,K) = VV(L)
      V(I,J,K,I) = VV(L)
      V(J,I,I,K) = VV(L)
      V(J,I,K,I) = VV(L)
      V(I,K,I,J) = VV(L)
      V(I,K,J,I) = VV(L)
      V(K,I,I,J) = VV(L)
      V(K,I,J,I) = VV(L)
   50 CONTINUE
C       NOW TRANSFORM THE FOURTH-RANK TENSOR, USING A(3,3) AS A PREFACTOR,
C        THAT IS, SUM REPEATEDLY WITH THE SECOND INDEX OF A.  A IS THE MATRIX
C        BROUGHT IN BY THE CALL, AND IS  OMA  FROM INERT OR  TUS  FROM SYMPOS.
      DO 60 I = 1,3
      DO 60 J = 1,3
      DO 60 K = 1,3
      DO 60 L = 1,3
      TV(I,J,K,L) = 0.0
      DO 60 LI = 1,3
      DO 60 LJ = 1,3
      DO 60 LK = 1,3
      DO 60 LL = 1,3
      TV(I,J,K,L) = TV(I,J,K,L) +
     1 A(I,LI)*A(J,LJ)*A(K,LK)*A(L,LL)*V(LI,LJ,LK,LL)
   60 CONTINUE
C  PATCH TO ADJUST SIGMAS WHEN ANY TRANSFORMED DIAGONAL
C    COMPONENT IS NEGATIVE AND PRINT MESSAGE
      NTV = 0
      IF(TV(1,1,1,1).LT.0) WRITE(LO,71)
      IF(TV(1,1,1,1).LT.0) NTV = NTV + 1
      IF(TV(2,2,2,2).LT.0) WRITE(LO,72)
      IF(TV(2,2,2,2).LT.0) NTV = NTV + 1
      IF(TV(3,3,3,3).LT.0) WRITE(LO,73)
      IF(TV(3,3,3,3).LT.0) NTV = NTV + 1
      IF(TV(1,2,1,2).LT.0) WRITE(LO,74)
      IF(TV(1,2,1,2).LT.0) NTV = NTV + 1
      IF(TV(1,3,1,3).LT.0) WRITE(LO,75)
      IF(TV(1,3,1,3).LT.0) NTV = NTV + 1
      IF(TV(2,3,2,3).LT.0) WRITE(LO,76)
      IF(TV(2,3,2,3).LT.0) GO TO 70
      IF(NTV.EQ.0) GO TO 90
   71 FORMAT(1H ,'VAR. OF U11 NEGATIVE AFTER TRANSF. TO CARTESIAN AXES')
   72 FORMAT(1H ,'VAR. OF U22 NEGATIVE AFTER TRANSF. TO CARTESIAN AXES')
   73 FORMAT(1H ,'VAR. OF U33 NEGATIVE AFTER TRANSF. TO CARTESIAN AXES')
   74 FORMAT(1H ,'VAR. OF U12 NEGATIVE AFTER TRANSF. TO CARTESIAN AXES')
   75 FORMAT(1H ,'VAR. OF U13 NEGATIVE AFTER TRANSF. TO CARTESIAN AXES')
   76 FORMAT(1H ,'VAR. OF U23 NEGATIVE AFTER TRANSF. TO CARTESIAN AXES')
C  FOLLOWING BRANCH USED WHEN ANY DIAG TV ELEMENT IS NEG
   70 CON2 = ESD(4)*ESD(4)
      CON = CON2
      CON3 = 0.625*CON2
      CON4 = 0.7906*ESD(4)
      V(1,1,1,1) = CON2
      V(2,2,2,2) = CON2
      V(3,3,3,3) = CON2
      V(1,2,1,2) = CON3
      V(1,3,1,3) = CON3
      V(2,3,2,3) = CON3
      IF(KA.GT.NTOT) GO TO 30
C   PRINT MESSAGE ONLY FOR UNIQUE ATOMS;EARLIER ONLY IF AXES OBLIQUE TOO
      WRITE(LO,910) ATNAME(NN),LN,ESD(4),CON4
  910 FORMAT(1H ,'VALUE OF ETA AND INPUT SIGMA(U) FOR ATOM ',A4,',POSN '
     1,I2,', LED TO NEGATIVE VARIANCE AFTER TRANSFORMATION TO CARTESIAN
     2 AXES.', /1X,'SIGMAS HAVE BEEN  SMOOTHED , ASSUMING SIGMA(U(II) ='
     3,F8.5, ' AND SIGMA U(IJ) =',F8.5 / 3X,
     4'  SEE DISCUSSION OF ETA AT START OF INSTRUCTIONS.'/)
      GO TO 30
   90 L = KK
      IF(MM.GT.1) L = NTS
      BB(L,1) = SQRT(TV(1,1,1,1))
      BB(L,2) = SQRT(TV(2,2,2,2))
      BB(L,3) = SQRT(TV(3,3,3,3))
      BB(L,4) = SQRT(TV(1,2,1,2))
      BB(L,5) = SQRT(TV(1,3,1,3))
      BB(L,6) = SQRT(TV(2,3,2,3))
  100 CONTINUE
      IF(NO.EQ.1.OR.KB.EQ.NTOS.OR.MM.GT.1) RETURN
      KA = NTOT + 1
      KB = NTOS
      KEQ = NA
C       NTOS SET EQUAL TO CURRENT NTOTS BY CALL OF THIS SUBROUTINE
C       (WHEN CALLED FROM INERT, CURRENT NTOTS IS FINAL NTOTS)
      LN = LN + 1
      NN = 0
      GO TO 15
      END
