      SUBROUTINE SOLVE 
C   MODIFIED SEPT 1985 TO INCLUDE PATCH FOR CALC & PRINT EIGENVALUES
C    AND EIGENVECTORS OF NORMAL EQUATION MATRIX
C
C     SET UP AND SOLVE MATRIX OF NORMAL EQUATIONS
C     SEQUENCE OF THE PARAMETERS OF THE SYSTEM OF LINEAR EQUATIONS
C     L11,L12,L13,L21,...,L33,T11,T12,...,T33,(S11,S12,...,S33), AND
C     THEN PARAMS FOR NON-RIGID MOTION:  FIRST, PHI-PHI FOR EACH GROUP
C     AND NEXT, FOR EACH GROUP IN ORDER, PHI-LAMBDA IN TWO DIRECTIONS
C     PERPENDICULAR TO THE LIBRATION AXIS AND PHI-TRANSL PARALLEL AND
C     IN THE TWO PERPENDICULAR DIRNS.
C   ONE DUMMY PARAMETER BECAUSE OF CONSTRAINT TRACE(S) = 0. FOR
C     SYMMETRY HIGHER THAN CI, APPROPRIATE ELEMENTS OF L,T,S SET = 0
C     AND MATRIX CONTRACTED. WHEN, BY SYMMETRY, PARAMETER J = PA-
C     RAMETER I (OR ITS NEGATIVE), MATRIX IS CONTRACTED BY COL I = COL I
C     + (OR -) COL J,ROW I= ROW I+(OR -) ROW J, VECTOR(I) = VECTOR(I) +
C     (OR -) VECTOR(J), AND THEN DELETION OF ROW J, COL J (EXCEPT FOR
C     THE DIAGONAL ELEMENT AND VECTOR ELEMENT J).
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON//AIDX(3000)
      COMMON/AMAT/AN(80,80)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),
     1     UCALC(150,6),NUORB(150),SIGB(150,6)
      COMMON/AXESN/ISPAX(15),LT(5,15),LAT(5,15)
      COMMON/AXESC/LBAT(5,15)
      CHARACTER*4 LBAT
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/IPAR/ NP(80)
C     COMMON/NOREIG/ IMAT, QV(80,80),VE(80,80)
C ***  /NOREIG/ USED HERE AND IN "OUTR" FOR EIGENVAL/VEC OF NORM EQN MAT
C * * Make common IO assignments.
      COMMON/IOSET/LI,LO,LTB
      DIMENSION KAN(80), WTT(150), IZ(5)
      DIMENSION AO(80),P(80),IPAIR(7,7)
      DIMENSION NRBP(150), NAFA(15), NONSY(15)
      EQUIVALENCE (KAN(1),AIDX(961)), (WTT(1),AIDX(451))
      EQUIVALENCE (INDAN,IAIDX1(501)),(IPAIR(1,1),AIDX(1701))
      EQUIVALENCE (P(1),AIDX(801)), (NONSY(1), IAIDX1(601))
      EQUIVALENCE (AO(1),AIDX(1041))
      EQUIVALENCE (IPAREX,IAIDX1(500))
      EQUIVALENCE(NRBP(1),IAIDX1(850)), (NAFA(1), IAIDX1(766))
      DOUBLE PRECISION  AN
C  **** NEED FOLLOWING WHEN ACTIVATE CALC EIGENVAL/VEC OF NORM EQN MATR
C     DOUBLE PRECISION  QV,VE
C
    1 FORMAT(1H ,5X,72H AT LEAST ONE DIAGONAL ELEMENT OF L IS NEGATIVE.
     1MODEL OR DATA SUSPECT.  )
    2 FORMAT(1H ,5X,72H AT LEAST ONE DIAGONAL ELEMENT OF T IS NEGATIVE.
     1MODEL OR DATA SUSPECT.  )
    3 FORMAT(1H ,5X, 90H MEAN SQUARE AMPLITUDE OF LIBRATION OF AT LEAST
     1ONE PRESUMED NON-RIGID GROUP IS NEGATIVE.  ,/, 28H     MODEL OR DA
     2TA SUSPECT.  )
C
C    DECREASE WEIGHTS TO AVOID OVERFLOW PROBLEMS (MAX PERMISSIBLE
C     NUMBER ON VAX IS 10**38; THAT ON 3033 IS 10**78)
C ***  CONSLV DEFAULT IS 0.01 UNLESS SOME OTHER VALUE INPUT
      DO 5 I = 1,NTOTS
      DO 5 J = 1,6
      WU(I,J) = WU(I,J)*CONSLV
    5 CONTINUE
C *** CLEAR THE ELEMENTS OF THE MATRIX (AN) AND THE VECTOR (P)
      DO 10 I = 1,80
      P(I) = 0.
      DO 10 K = 1,80
      AN(I,K) = 0.
   10 CONTINUE
      NMA = NP1
C ***  NMA WILL BE THE ACTUAL DIMENSION OF THE MATRIX
      NNP1 = NP1
      IF(NONRIG.EQ.0) GO TO 15
C ***  WHEN NO NONRIGID GROUPS, CAN SKIP ALL EXPANSION OF MATRIX THAT
C ***    INVOLVES THEM
      NNP1 = NNP1 + NONRIG
      IF(ICORL.GE.0) NNP1 = NNP1 + 5*NONRIG
C ***  (WHEN ICORL.GE.0, CALCULATING CORRELNS INTERNAL & OVERALL MOTION)
C ***   BUT NO CORRELATIONS POSSIBLE FOR GROUPS WITH ONLY ONE ATOM
      DO 2010 I =1,NONRIG
      IF(NAFA(I).LT.2.AND.ICORL.GE.0.AND.NONSY(I).NE.0) NNP1 = NNP1-5
 2010 CONTINUE
      IF(NNP1.GT.78) GO TO 999
C ***  INTERGROUP CORRELN INDETERMINATE WITH OVERALL/INTERNAL CORRELN
      IF(ICORL.GE.0) GO TO 18
C ***  FOLLOWING PATCH (THRU 19) CLEARS IPAIR(I,J) AND THEN SETS IT UP
C ***    AS INDEX OF GROUPS THAT CONTAIN COMMON ATOMS.  IPAIR IS
C ***    SET EQUAL TO THE PARAMETER NUMBER FOR CORRELN OF PHI VALUES
C ***    FOR THESE GROUPS I AND J.
    9 DO 11 I = 1,7
      DO 11 J = 1,7
   11 IPAIR(I,J) = 0
      DO 19 I = 1,NA
      J1 = 0
      NN = NRBP(I)
      DO 12 J = 1,5
      IH = NN/16
      IZ(J) = NN - 16*IH
      IF(IZ(J).EQ.0) GO TO 13
      NN = IH
      J1 = J1 + 1
   12 CONTINUE
   13 IF(J1.LE.1) GO TO 19
C *** WHEN J1 IS 2 OR 3, ATOM I IS IN 2 OR 3 DIFFERENT N-R GROUPS
      KK = IZ(1)
      LL = IZ(2)
      IF(IPAIR(KK,LL).NE.0) GO TO 14
      NNP1 = NNP1 + 1
      IPAIR(KK,LL) = NNP1
      IPAIR(LL,KK) = IPAIR(KK,LL)
   14 IF(J1.EQ.2) GO TO 19
      MM = IZ(3)
      IF(IPAIR(KK,MM).NE.0) GO TO 16
      NNP1 = NNP1 + 1
      IPAIR(KK,MM) = NNP1
      IPAIR(MM,KK) = IPAIR(KK,MM)
   16 IF(IPAIR(LL,MM).NE.0) GO TO 19
      NNP1 = NNP1 + 1
      IPAIR(LL,MM) = NNP1
      IPAIR(MM,LL) = IPAIR(LL,MM)
   19 CONTINUE
   18 CONTINUE
      NMA = NNP1
   15 KB = 1
      KE = NA
      ISY = 0
C       ISY = 0 DURING CALCULATIONS FOR UNIQUE POSITIONS. SET TO -1
C FOR CALCULATIONS FOR ALL SYMMETRY-RELATED POSITIONS.
      I1 = NTOT
      J1 = 0
      IF(NONRIG.EQ.0) GO TO 45
C      IF NON-RIGID GROUPS, CALC LIBR AXES FOR THEM FOR INPUT POSITIONS
C        -- THEN, CALL "LOCAL" AND CALC AXES FOR LOCAL REF SYSTEMS
      CALL DERNOP
      ILOC = 1
      CALL LOCAL(ILOC)
   45 DO 22 K = KB,KE
      J1 = J1 + 1
      IF(WTT(K).EQ.800.0) GO TO 22
C  ATOMS WITH WEIGHT 800.0 TO BE IGNORED IN ANALYSIS OF MOTION,
C    EXCEPT INSOFAR AS THEY DEFINE NON-RIGID LIBRATION AXES AND
C    ARE REPRODUCED BY SYMMETRY OPERATIONS FOR THAT PURPOSE
      CALL DERIVP(K)
      IF(NRBP(K).EQ.0)  GO TO 21
      CALL DERNP(K)
   21 DO 20 K1 = 1,6
C *** UNTIL 21.IV.87, NEXT LINE SAID "GO TO 22" -- SINCE NO ZERO
C ***  WTS FORMERLY PERMITTED, NO PROBLEMS CAUSED, BUT IT IS NOT
C ***  LOGICAL, AND NOW PERMIT ZERO WTS FOR U(I,J) IDENTICALLY 0
C      IF(WU(K,K1).EQ.0.)  GO TO 20
      CALL INTSET(K1,I,L)
      CALL DERIV(I,L)
      IF(NONRIG.EQ.0)  GO TO 25
      IF(NRBP(K).EQ.0)  GO TO 70
      CALL DERNON(K,I,L)
      GO TO 25
   70 NHP1 = NP1 + 1
      DO 75 I = NHP1,NNP1
      AO(I) = 0.
   75 CONTINUE
C     SET UP MATRIX AND VECTOR FOR NNP1 UNRESTRICTED PARAMETERS
   25 DO 30 I = 1,NNP1
C   AO(I) COME FROM SUBROUTINES DERIV AND DERNON
C *** PATCH 21.IV.87   next line new:
      IF(WU(K,K1).EQ.0.) WU(K,K1) = CONSLV
C ***  KNT changed right side of that from 1.0 to CONSLV, 21.IV.91
C *** END PATCH
      AO(I) = AO(I)*WU(K,K1)
      P(I) = P(I) + AO(I)*AUOBS(K,K1)*WU(K,K1)
      DO 30 J = 1,I
      AN(I,J) = AN(I,J) + AO(I)*AO(J)
      AN(J,I) = AN(I,J)
   30 CONTINUE
   20 CONTINUE
      IF(NONRIG.EQ.0) GO TO 22
      IF(NO.EQ.1) GO TO 22
      IF (J1.LT.NA) GO TO 22
C      FOLLOWING IS TO GIVE CORRECT LIBRATION AXES FOR NON-RIGID GROUPS
C        IN SYM-RELATED POSITIONS.  FIRST TIME I1 = NTOT. LATER I1 = NA.
C        HOWEVER, DERNOP NOT CALLED AGAIN AFTER FINISH LAST POSITION.
      IF(ISY.EQ.(-1).AND.K.EQ.NTOTS) GO TO 22
      J1 = 0
      ILOC = ILOC + 1
C ***  ILOC IS A TALLY FOR EQUIV POSNS, USED ONLY IN LABELLING OUTPUT
      DO 320 I = 1,NONRIG
C ***  WHEN ISPAX NOT ZERO, FIVE ATOMS USED TO DEFINE NONRIGID AXES.
C ***    OTHERWISE ONLY TWO ARE USED
      J2 = 2
      IF(ISPAX(I).NE.0) J2 = 5
      DO 320 J = 1,J2
      LAT(J,I) = LAT(J,I) + I1
  320 CONTINUE
      CALL DERNOP
      CALL LOCAL(ILOC)
   22 CONTINUE
      IF(IMAT.LT.100) GO TO 35
      CALL OUTH6
      DO 32 I=1,NNP1
      WRITE(LO,31) (AN(I,J),J=1,NNP1),P(I)
   31 FORMAT(1H ,11(1X,E10.4,1X))
      WRITE(LO,33)
   33 FORMAT(1H )
   32 CONTINUE
   35 CONTINUE
      IF(NO.LE.2) GO TO 55
C      MOLECULES WITH SYMMETRY C1 HAVE ONLY NA ATOMS FOR ANALYSIS.
C        THOSE WITH SYMMETRY CI (NO 2) HAVE ALL CONTRIBUTIONS TO NORMAL
C        EQUATIONS IDENTICAL FOR SYM-RELATED ATOMS WHEN REFERRED TO THE
C        CENTER OF SYMMETRY (CENTER OF MASS) AS ORIGIN.
      IF(ISY.NE.0) GO TO 55
C      SET SUMMATION LIMITS FOR CALCULATING CONTRIBUTIONS TO NORMAL
C       EQUATIONS FOR ALL ATOMS IN THE MOLECULE (GENERATED BY SYMPOS)
      KB = NTOT + 1
      KE = NTOTS
      I1 = NA
      ISY = -1
      GO TO 45
   55 IF(NPARS.EQ.0)  GO TO 110
      NSUM = 0
      DO 80 I = 13,21,4
      NSUM = NSUM + NP(I)
   80 CONTINUE
      IF(NSUM.EQ.0)  GO TO 100
C     IMPOSE RESTRICTION THAT TRACE OF S EQUALS 0 IF NOT ALREADY SO.
      NMA = NMA + 1
      IF(NMA.GT.80)  GO TO 999
      DO 90 I = 13,21,4
      AN(I,NMA) = 1.
      AN(NMA,I) = 1.
   90 CONTINUE
  100 IF(IMAT.GE.250) GO TO 43
      IF(NP(14).NE.NP(16))  GO TO 110
      IF(NP(15).NE.NP(19))  GO TO 110
      IF(NP(18).NE.NP(20))  GO TO 110
      IORIG = 0
C     SET CONSTRAINTS FOR PARAMETERS REQUIRED BY POINT GROUP SYMMETRY
C     AND NON-RIGID BODY REQUIREMENTS
  110 DO 120 I = 1,NNP1
C ***  NP(I) SET UP IN "SYMET" OR "NPAR" FOR PARAM 1-21 (OR 1-12),
C ***       IN MAIN FOR THOSE INVOLVING ATTACHED RIGID GROUPS
      IF(NP(I).EQ.I)  GO TO 120
      IF(NP(I).EQ.0) GO TO 160
      IF(NPARS.EQ.0) GO TO 170
      IF(I.NE.17) GO TO 170
C     S22 (I=17) MAY EQUAL S11 (I = 13) OR -S11 IN CERTAIN POINT GROUPS.
C       THIS IS HANDLED BY EXPANSION OF MATRIX TO BE CONSISTENT WITH THE
C       CONDITION TRACE OF S = 0 (ABOVE). IF S33 = S22 = S11, EACH = 0.
      NMA = NMA + 1
      IF(NP(I).GT.0) GO TO 115
      AN(17,NMA) = 1.
      AN(NMA,17) = 1.
      GO TO 117
  115 AN(17,NMA) = -1.
      AN(NMA,17) = -1.
  117 AN(13,NMA) = 1.
      AN(NMA,13) = 1.
      GO TO 120
  170 CONTINUE
C     IMPOSE OTHER CONSTRAINTS BY CONTRACTING AND FOLDING MATRIX
      IF(NP(I)) 140,160,190
  140 INP = IABS(NP(I))
C     PARAM I = NEGATIVE OF PARAM INP
      DO 145 K=1,NNP1
      AN(K,INP) = AN(K,INP)-AN(K,I)
  145 CONTINUE
      DO 147 K=1,NNP1
      AN(INP,K) =AN(INP,K) - AN(I,K)
  147 CONTINUE
      P(INP) = P(INP) - P(I)
      DO 148 K=1,NNP1
      AN(K,I) = 0
      AN(I,K) = 0
  148 CONTINUE
      AN(I,I) = 1.
      P(I) = 0
      GO TO 120
C     PARAM I = PARAM IJ
  190 IJ=NP(I)
      DO 195 K=1,NNP1
      AN(K,IJ) = AN(K,IJ)+AN(K,I)
  195 CONTINUE
      DO 197 K=1,NNP1
      AN(IJ,K) = AN(IJ,K) + AN(I,K)
  197 CONTINUE
      P(IJ) = P(IJ) + P(I)
      DO 198 K=1,NNP1
      AN(K,I) = 0
      AN(I,K) = 0
  198 CONTINUE
      AN(I,I) = 1.
      P(I) = 0
      GO TO 120
C     IF (NP(I).EQ.0)  DELETE ITH PARAMETER
  160 DO 165 J = 1,NNP1
      AN(I,J) = 0.
      AN(J,I) = 0.
  165 CONTINUE
      P(I) = 0.
      AN(I,I) = 1.
  120 CONTINUE
   43 CONTINUE
      IF(IMAT.LT.200.OR.NO.LE.2) GO TO 42
C ***  WHEN NO.LE.2), THERE ARE NO SYMMETRY OPERATIONS AFFECTING U'S
      CALL OUTH6
      DO 40 I=1,NNP1
      WRITE(LO,31) (AN(I,J),J=1,NNP1),P(I)
      WRITE(LO,33)
   40 CONTINUE
   42 CONTINUE
C *** PATCH FOR OUTPUT OF MATRIX WHEN IEIG.GT.0, UNFORMATTED ON UNIT 6
C ***    AND FORMATTED ON UNIT 2 (FOR CHECKING) (LATTER NOT OPERATIVE)
C ***  FURTHER, IF IEIG .GT.1, PROVISION FOR LATER-TO-BE-ADDED CALC
C ***    OF EIGENVALUES, EIGENVECTORS OF NORM EQN MATRIX IN THIS PROGR
      IF(IEIG.LE.0) GO TO 3200
C ***  SUBSTITUTE NEXT LINE FOR PREV IF INCLUDE CALC, PRINT OF EIGENVALS
C ***     AND EIGENVECTORS IN THIS PROGRAM (SEE BETWEEN C3000 AND 3200)
C     IF(IEIG.LE.0) GO TO 3000
C     DO 3100 I = 1,NNP1
C     WRITE(M,3500) I, (AN(I,J), J = 1,NNP1)
C3500 FORMAT(2X,I2,10(2X,F10.6),/3(5X,10(2X,F10.6),/))
C3100 CONTINUE
      WRITE (6) ((AN(I,J),J=1,NNP1), I = 1,NNP1)
      WRITE(LO,3510) NNP1, NNP1
 3510 FORMAT(1H ,'MATRIX OF NORMAL EQUATIONS WRITTEN ON UNIT 6, UNFORMAT
     1TED, ((A(I,J), J = 1,',I3,'), I = 1,',I3,')')
C3000 IF(IEIG.LE.1) GO TO 3200
C *** PATCH FOR CALC, PRINT EIGENVALUES, VECTORS OF NORM EQN MATRIX
C     DO 2000 III = 1,NNP1
C     DO 2000 JJJ = 1,NNP1
C     QV(III,JJJ) = AN(III,JJJ)
C2000 CONTINUE
C     CALL EIGEND(QV,VE,NMA)
C     CALL OUTR14
C ***  END OF PATCH
 3200 CALL MATNVV(AN,NMA,80,1,P,DET)
      IF(IMAT.GE.100) WRITE(LO,1045) (I,P(I), I = 1,NNP1)
 1045 FORMAT(10X,I5,5X,F15.8)
C ***  OPTIONAL PRINT PATCH FOR INVERTED MATRIX
      IF(IMAT.NE.175.AND.IMAT.NE.225) GO TO 1060
      CALL OUTH6
      DO 1050 I = 1,NNP1
      WRITE(LO,31) (AN(I,J), J = 1,NNP1), P(I)
      WRITE(LO,33)
 1050 CONTINUE
 1060 INDAN = 0
      DO 200 I = 1,NNP1
      KAN(I) = 0
      IF(AN(I,I).GE.0.)  GO TO 200
      KAN(I) = I
      INDAN = 1
  200 CONTINUE
      IF(INDAN.EQ.0)  GO TO 210
      CALL OUTR12
      GO TO 220
  210 CALL OUTH6
  220 IF(IMAT.GE.250) GO TO 1010
      DO 1000 I = 2,NNP1
C     THIS SECTION RESETS THE VALUES OF PARAMETERS DELETED BECAUSE
C          THEY ARE RELATED BY SYMMETRY TO OTHERS.   THOSE DELETED
C          BECAUSE THEY ARE IDENTICALLY ZERO ARE NOT RESET, BUT THEIR
C          ESD'S AND CORRELATION COEFFICIENTS ARE SET TO ZERO.
C       NP(1) ALWAYS IS 1.
      IF(NP(I).EQ.I) GO TO 1000
      IF (NP(I).EQ.0) GO TO 500
      IF(NPARS.EQ.0) GO TO 230
C     NEED NOT RESET S11, S22, S33 BECAUSE THEY WERE LINKED BY EXPANSION
C       OF MATRIX IF SYMMETRY-RELATED AND NON-ZERO.
      IF(I.EQ.13.OR.I.EQ.17.OR.I.EQ.21) GO TO 1000
  230 L = I - 1
      DO 900 J = 1,L
      IF(NP(I).EQ.J) GO TO 800
  900 CONTINUE
      K = -NP(I)
      DO 700 J = 1,L
      IF(K.EQ.J) GO TO 600
  700 CONTINUE
      GO TO 1000
  600 P(I) = -P(J)
      DO 610 K = 1,NNP1
      AN(I,K) = -AN(J,K)
      AN(K,I) = -AN(K,J)
  610 CONTINUE
      AN(I,I) = AN(J,J)
      GO TO 1000
  800 P(I) = P(J)
      DO 810 K = 1,NNP1
      AN(I,K) = AN(J,K)
      AN(K,I) = AN(K,J)
  810 CONTINUE
      AN(I,I) = AN(J,J)
      GO TO 1000
C        SET ESD'S AND RHO'S TO ZERO FOR PARAMETERS THAT ARE IDENTICALLY
C          ZERO BECAUSE OF SYMMETRY AND PERHAPS CONDITION TRACE(S) = 0.
  500 DO 510 K = 1,NNP1
      AN(K,I) = 0.0
      AN(I,K) = 0.0
  510 CONTINUE
 1000 CONTINUE
 1010 CONTINUE
C      PRINT MESSAGE IF ANY L(I,I), T(I,I), OR NON-RIGID LIBRATION
C        PARAMETER IS NEGATIVE.
      IF(P(1).LT.0) GO TO 400
      IF(P(4).LT.0) GO TO 400
      IF(P(6).LT.0) GO TO 400
      GO TO 410
  400 WRITE(LO,1)
  410 IF(P(7).LT.0) GO TO 420
      IF(P(10).LT.0) GO TO 420
      IF(P(12).LT.0) GO TO 420
      GO TO 430
  420 WRITE(LO,2)
  430 IF (NONRIG.EQ.0) GO TO 460
      NHP1 = NP1 + 1
      NHPA1 = NP1 + NONRIG
      DO 440 I = NHP1,NHPA1
      IF(P(I).GE.0) GO TO 440
      WRITE(LO,3)
      GO TO 460
  440 CONTINUE
  460 CONTINUE
      ISOLV = 1
      RETURN
  999 IPAREX = -1
C     NUMBER OF PARAMETERS EXCEEDS DIMENSION OF MATRIX
      RETURN
      END
