      SUBROUTINE SORTSG(NSIG)
C ***  ALTERED 23.I.87 SO LOOKS ONLY AT FIRST (NA-N8) (SORTED) INPUT
C ***    ATOMS, WHERE N8 IS THE NUMBER WITH WEIGHT 800.0
C     SORT INPUT OF SIGMA U'S INTO SEQUENCE OF ATOMS FOR ANALYSIS
C       AND GENERATE SIGU(I,K) FOR EACH ATOM OF WT 800.0 IF NO SIGU
C       WAS INPUT FOR THAT ATOM.  SORTING IS ON BASIS OF ATOM NAMES,
C       WHICH ARE  ATNAME  FOR INPUT PARAMETERS AND  NTNAME  FOR ESDS
C
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON/AIDCH/NTNAME(150)
      COMMON/CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,
     1 NTOT,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/IAID1/IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
      DIMENSION SIGH(6)
      EQUIVALENCE (SIGH(1),AIDX(1))
C
      CHARACTER*4  NTNAME,INAME
      CHARACTER*4 NAME1,ATNAME,TISET,TITLE*80, ITBL*3, NAME2*5
C
      IF(NSIG.EQ.1)  RETURN
      NST = 0
      I2 = NA - N8
C ***  THUS I2 IS THE NUMBER OF ATOMS WHOSE U'S ARE TO BE USED IN THE
C ***     ANALYSIS OF MOTION.  THESE I2 ATOMS HAVE BEEN SORTED INTO
C ***     THE FIRST I2 POSITIONS IN ATOM-PARAMETER LIST
      DO 10 I = 1,I2
      DO 20 K = 1,NSIG
      IF(ATNAME(I).EQ.NTNAME(K))  GO TO 30
      IF(K.NE.NSIG) GO TO 20
      NST = NST + 1
C   WHEN K = I2, NO ATOM NAMES HAVE MATCHED
      WRITE(LO,100) ATNAME(I), NSIG
  100 FORMAT(1H ,'ATOM NAME ',A4,' IN SORTED ATOM INPUT MATCHES NONE',
     1' OF THE',I4,' ATOM NAMES INPUT WITH ESDs.  Us FOR THIS ATOM'
     2/3X,'ARE TO BE INCLUDED IN THE ANALYSIS OF MOTION; ESDs MUST ',
     3'ALSO BE, IF THEY ARE INPUT FOR ANY ATOMS.')
      GO TO 20
   30 INAME = NTNAME(I)
      NTNAME(I) = NTNAME(K)
      NTNAME(K) = INAME
      DO 40 IH = 1,6
      SIGH(IH) = SIGB(I,IH)
      SIGB(I,IH) = SIGB(K,IH)
      SIGB(K,IH) = SIGH(IH)
   40 CONTINUE
      GO TO 10
   20 CONTINUE
   10 CONTINUE
      IF(NST.NE.0) STOP
C  NST NON-ZERO MEANS AT LEAST ONE NON-MATCH OF ATOM NAMES
      IF(N8.EQ.0) RETURN
C  GENERATE SIGB(I,K) = 1.0 FOR ATOMS OF WT 800.0 (WHICH ARE
C     AT THE END OF THE FIRST NA ATOMS) IF ESDS INPUT FOR FEWER
C *** THAN NA ATOMS.  NOTE THESE ARE NOW GENERATED REGARDLESS
C *** OF ANY THAT MAY HAVE BEEN INPUT.  INPUT VALUES IGNORED
      N1 = NA - N8 + 1
      NT = 0
      DO 50 I = N1,NA
      IF(WT(I).NE.800.0) GO TO 50
      NT = NT + 1
      DO 45 K = 1,6
      SIGB(I,K) = 1.0
   45 CONTINUE
   50 CONTINUE
      IF(NT.NE.0) WRITE(LO,110) NT
  110 FORMAT(1H ,'SIGB(I,K) = 1.0 GENERATED FOR ',I3,
     1 ' ATOMS OF WT 800.0')
      NT = NT + NSIG
      IF(NT.LT.NA) GO TO 300
C  NOW CHANGE ISIG TO NA OR -NA SO OK FOR VIBAMP AND SGTRAN
      IF(ISIG.LT.0) GO TO 150
      ISIG = NA
      RETURN
  150 ISIG = -NA
      RETURN
  300 WRITE(LO,105)
      STOP
  105 FORMAT(1H ,'ABSOLUTE VALUE OF ISIG ADDED TO NO. OF ATOMS OF WEIGHT
     1 800.0 IS LESS THAN NA.  CHECK INPUT.')
      END
