      SUBROUTINE STAS
C
C     CALCULATE ALTERNATIVE SYSTEM OF INTERPRETATION WITH NON-INTERSECTI
C     AXES OF LIBRATION
C     IF ONE OR MORE EIGENVALUES OF THE L-TENSOR ARE NEGATIVE OR ZERO,
C     CALCULATION OF ALTERNATIVE SYSTEM OF INTERPRETATION SKIPPED
C
C     VL = EIGENVECTORS OF L IN I FRAME
C     AHL(I,I) = EIGENVALUES L IN I FRAME
C     VLT = TRANSPOSE OF VL
C     AHS(3,3) = ORIG. S TENSOR IN I FRAME
C     SL = ORIG. S TENSOR IN L FRAME
C
      COMMON//AIDX(3000)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1SYML(3)
      COMMON/TMCSIS/TCIC(3,3),TCIU(3,3),TCINVC(3,3),TCINVU(3,3),SCG(3),
     1 OMIN(3,3), TROI(3,3)
C * * Make common IO assignments.
      COMMON/IOSET/LI,LO,LTB
      DIMENSION EFSCT(3),SCRP(3),RHO(3,3),SL(3,3),AHL(3,3),AHS(3,3)
      DIMENSION P(80),VL(3,3),VLT(3,3)
      DIMENSION AOT(3,3),V(6),UH(3,3),AOC(3,3),AOL(3,3),TTCNVU(3,3)
      EQUIVALENCE(EFSCT(1),AIDX(601)),(SCRP(1),AIDX(605))
      EQUIVALENCE(RHO(1,1),AIDX(2811))
      EQUIVALENCE (VL(1,1),AIDX(2641)),(AHL(1,1),AIDX(2601))
      EQUIVALENCE (P(1),AIDX(801)),(AHS(1,1),AIDX(2781))
      EQUIVALENCE (SL(1,1),AIDX(2791)),(VLT(1,1),AIDX(2821))
      EQUIVALENCE (UH(1,1),AIDX(2490)),(V(1),AIDX(2435)),(AOT(1,1),
     1 AIDX(2721)),(AOL(1,1),AIDX(2711)),(AOC(1,1),AIDX(2701))
     2 , (TTCNVU(1,1),AIDX(2751))
C
      CALL TRAMA(VL,VLT)
      IF(NPARS.EQ.0) RETURN
      IF (IFU.GT.0) GO TO 5
C        IF ANY EIGENVALUE OF L IS NEGATIVE, IT IS SET TO ZERO BY OUTR3
C          AFTER ATINT.  IF NOT THROUGH ATINT (BECAUSE IFU.LE.0), THEN
C          MUST CHECK FOR NEGATIVE AHL(I,I) HERE.
      DO 3 K = 1,3
      IF(AHL(K,K).GT.0.) GO TO 3
      AHL(K,K) = 0.
C      IF ANY EIGENVALUE OF L IS NEGATIVE, MUST SET ONE TO ZERO FOR
C        PROPER FUNCTIONING (BYPASSING) OF LIBCOR.
      GO TO 60
    3 CONTINUE
    5 DO 50 I = 1,3
      IF(AHL(I,I).EQ.0.)  GO TO 60
   50 CONTINUE
      M = 12
      DO 10 I = 1,3
      DO 10 K = 1,3
      M = M + 1
      AHS(I,K) = P(M)
   10 CONTINUE
      CALL TRIPLE(VLT,AHS,VL,SL)
      DO 15 I = 1,3
      DO 15 J = 1,3
      RHO(I,J) = 0.
   15 CONTINUE
      DO 20 I = 1,3
      DO 20 J = 1,3
      DO 20 K = 1,3
      RHO(J,I) = RHO(J,I) + EPSIJK(I,J,K)*SL(J,K)/AHL(J,J)
   20 CONTINUE
      DO 30 I = 1,3
      SCRP(I) = SL(I,I)/AHL(I,I)
      EFSCT(I) = SCRP(I)*SQRT(AHL(I,I))
   30 CONTINUE
      DO 100 I=1,6
      K=I+6
  100 V(I) = P(K)
C     V(I) IS NOW ORIGINAL T IN I-FRAME
      CALL VMLT(V,UH)
      CALL TRIPLE(VLT,UH,VL,AOT)
C     AOT IS NOW ORIGINAL T IN L-FRAME
C     CALCULATE REDUCED T FOR THIS DESCRIPTION
      DO 110 K=1,3
      J = K+1
      IM = MOD(K,3) + 1
      JM = MOD(J,3) + 1
      AOT(K,K) = AOT(K,K) - SL(IM,K)*SL(IM,K)/AHL(IM,IM)
     .          -SL(JM,K)*SL(JM,K)/AHL(JM,JM)
      AOT(K,IM)=AOT(K,IM)-SL(K,K)*SL(K,IM)/AHL(K,K)-SL(IM,K)*SL(IM,IM)/
     .    AHL(IM,IM) - SL(JM,K)*SL(JM,IM)/AHL(JM,JM)
      AOT(IM,K) = AOT(K,IM)
  110 CONTINUE
      CALL TRIPLE(VL,AOT,VLT,AOL)
      CALL TRAMA(TROI,UH)
      CALL TRIPLE(TROI,AOL,UH,AOC)
C     REDUCED T IS NOW AOT IN L-FRAME, AOL IN INERTIAL FRAME, AOC IN
C     CARTESIAN CRYSTAL SYSTEM
      IF(NS.LT.0) RETURN
      CALL OUTH6
C     PRINT SCREW PITCHES, EFFECTIVE SCREW TRANSLATIONS AND REDUCED T
      CALL OTHR22
      CALL OUTR10
      RETURN
   60 IORIG = 0
      RETURN
      END
