      SUBROUTINE XASIGN
C *** SIGNIF CHANGES SEPT 1985: ADD MORE ELEMENTS, FLAG H AND D
C  WILL RECOGNIZE EITHER UPPER-CASE OR LOWER-CASE LETTERS
C  CALLED BY RDIN3, WHEN IFU1.EQ.0 (FIRST PASS-THROUGH FOR A GIVEN SET
C    OF PARAMETERS).
C  ASSIGNS (WHEN NOT INCLUDED WITH INPUT) ATOMIC WEIGHTS AUTOMATICALLY
C    FOR FIRST 53 ELEMENTS AND D, W, Re, Os, Ir AND Pt, NOT INCLUDING
C    He, Ne, Ar, Kr and Tc.  FOR ALL OTHER ELEMENTS THE ATOMIC WEIGHT
C    MUST BE ASSIGNED EARLIER.  FURTHER, IF FOR ANY OF THESE ELEMENTS
C    THE ATOMIC WEIGHT INPUT IS 800., 999.9, OR NEGATIVE, THAT ELEMENT
C    WILL BE SKIPPED, SO THESE SPECIAL VALUES MAY BE INPUT FOR THEM.
C
C  IF IT DOES NOT RECOGNIZE AN ELEMENT, IT LEAVES THE INPUT VALUE OF
C    THE ATOMIC WEIGHT UNCHANGED.
C
C  THE FIRST NON-BLANK CHARACTERS IN THE ATOM NAME MUST BE THE CHEMICAL
C    SYMBOL FOR THE ELEMENT; THE PROGRAM EXAMINES THE FIRST FOUR COLUMNS
C    (SKIPPING BLANKS) AND LOOKS FOR THE STANDARD CHEMICAL ONE- OR TWO-
C    LETTER ELEMENTAL SYMBOL.
C  SETS AW NEGATIVE FOR ISOTROPIC ATOMS UNLESS INPUT AW = 800. OR 999.9
C
      COMMON//AIDX(3000)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2  IEIG, IMAT, IOUT, IRECAL, IFREQ
      COMMON/CORDIN/ IRIDE, IMIN, IUNC, IHAT(150), NUNC(20),TUNC(20,3),
     1 TOR(3,3), XCG(3),IHPR
C     COMMON/CORDIC/ RIDA(20), RIDB(20), AMIN1(20), AMIN2(20),
C    1 UNC1(20), UNC2(20)
      COMMON/FORM/IFMX,IFMB,ILIST
C     COMMON/FORMC/FMSX(18),FMSB(18)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
C * * Make common IO assignments.
      COMMON/IOSET/LI,LO,LTB
      DIMENSION ATXX(4),ASYM(21),NSYM(150),SSYM(15), ALPH(26),B22(150)
      DIMENSION ALCSYM(21), SLCSYM(15), ALPHLC(26)
      EQUIVALENCE  (AIDX(201), B22(1))
      CHARACTER*1 ATXX, BLK, ASYM, SSYM, ALPH, ALPHLC,SLCSYM, ALCSYM
      CHARACTER*4 NAME1,ATNAME,TISET,TITLE*80, ITBL*3,NAME2*5
      DATA ALCSYM/'a','b','c','d','f','g','h','i','k','l','m','n','o',
     1   'p','s','t','v','z','r','w','y'/
      DATA   ASYM/'A','B','C','D','F','G','H','I','K','L','M','N','O',
     1   'P','S','T','V','Z','R','W','Y'/
      DATA   BLK/' '/
      DATA  ALPH/'A','B','C','D','E','F','G','H','I','J','K','L','M',
     1  'N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
      DATA ALPHLC/'a','b','c','d','e','f','g','h','i','j','k','l','m',
     1  'n','o','p','q','r','s','t','u','v','w','x','y','z'/
      DATA SSYM/'A','C','E','G','I','L','N','O','R','S','U','B','D',
     1  'H','T'/
      DATA SLCSYM/'a','c','e','g','i','l','n','o','r','s','u','b','d',
     1  'h','t'/
C
      N = 0
      NN = 0
      NISO = 0
      NSP = 0
      NB = 0
C  N = TALLY FOR ATOMS ASSIGNED ATOMIC WEIGHTS, NN FOR UNRECOGNIZED SYM-
C    BOLS (INCLUDING ALL BLANK), NB FOR ALL BLANK, NSP FOR SPECIAL INPUT
C    VALUES (800.0, 999.9, OR NEGATIVE), AND NISO FOR ISOTROPIC ATOMS
C    WHOSE WTS ARE SET NEGATIVE BY THIS SUBROUTINE
      IHPR = 0
C ***   IHPR ADDED 15.IV.87; SIGNALS PRESENCE OF ANY ANISO H OR D
      DO 9 I = 1,150
      NSYM(I) = 0
      IHAT(I) = 0
    9 CONTINUE
      DO 3010 L = 1,NTOT
      IF(WT(L).EQ.800.0.OR.WT(L).EQ.999.9.OR.WT(L).LT.0.0) GO TO 2910
C  DO NOT ASSIGN WEIGHT IF IT ALREADY HAS A SPECIAL VALUE
      DO 3011 I=1,4
 3011  ATXX(I)=ATNAME(L)(I:I)
C   THE (I:I) IN PREV LINE EQUATES ATXX(I) WITH Ith CHARACTER OF ATNAME
C     (NOTE THAT ATXX IS CHARACTER*1, WHILE ATNAME IS CHARACTER*4)
      DO 2900 I = 1,4
      IF(ATXX(I).EQ.BLK) GO TO 2900
      II = I + 1
      DO 300 J = 1,21
      IF(ASYM(J).NE.ATXX(I).AND.ALCSYM(J).NE.ATXX(I)) GO TO 300
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     1   170,180,190,200,210) J
  300 CONTINUE
C *** IF HERE, THERE IS NO MATCH OF FIRST LETTER; UNRECOGNIZED ELEMENT
      GO TO 17
C *** FIRST LETTER IS A; ELEMENT IS AG, AL OR AS IF WT TO BE ASSIGNED.
   10 IF(I.EQ.4) GO TO 17
C ***  IF I = 4, A IS IN COLUMN 4 AND THERE IS NO SUCH ELEMENT
      IF(ATXX(II).NE.SSYM(4).AND.ATXX(II).NE.SLCSYM(4)) GO TO 12
      WT(L) = 107.87
      GO TO 2990
   12 IF(ATXX(II).NE.SSYM(6).AND.ATXX(II).NE.SLCSYM(6)) GO TO 14
      WT(L) = 26.98
      GO TO 2990
   14 IF(ATXX(II).NE.SSYM(10).AND.ATXX(II).NE.SLCSYM(10)) GO TO 17
      WT(L) = 74.92
      GO TO 2990
   17 NN = NN + 1
C *** SAVE SERIAL NUMBER OF UNRECOGNIZED ATOM FOR LATER PRINTING
      NSYM(NN) = L
      GO TO 3000
C ***  FIRST LETTER IS B; B OR BE OR BR, OR UNRECOGNIZED
   20 IF(I.EQ.4) GO TO 28
      IF(ATXX(II).NE.SSYM(3).AND.ATXX(II).NE.SLCSYM(3)) GO TO 23
      WT(L) = 9.01
      GO TO 2990
   23 IF(ATXX(II).NE.SSYM(9).AND.ATXX(II).NE.SLCSYM(9)) GO TO 26
      WT(L) = 79.9
      GO TO 2990
C *** ELEMENT IS NOT BE OR BR; EITHER B OR UNRECOGNIZED
   26 DO 27 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
   27 CONTINUE
C *** ELEMENT IS BORON
   28 WT(L) = 10.81
      GO TO 2990
   30 IF(I.EQ.4) GO TO 39
      IF(ATXX(II).NE.SSYM(1).AND.ATXX(II).NE.SLCSYM(1)) GO TO 31
      WT(L) = 40.08
      GO TO 2990
   31 IF(ATXX(II).NE.SSYM(6).AND.ATXX(II).NE.SLCSYM(6)) GO TO 32
      WT(L) = 35.45
      GO TO 2990
   32 IF(ATXX(II).NE.SSYM(8).AND.ATXX(II).NE.SLCSYM(8)) GO TO 33
      WT(L) = 58.93
      GO TO 2990
   33 IF(ATXX(II).NE.SSYM(9).AND.ATXX(II).NE.SLCSYM(9)) GO TO 34
      WT(L) = 52.0
      GO TO 2990
   34 IF(ATXX(II).NE.SSYM(11).AND.ATXX(II).NE.SLCSYM(11)) GO TO 35
      WT(L) = 63.54
      GO TO 2990
   35 IF(ATXX(II).NE.SSYM(13).AND.ATXX(II).NE.SLCSYM(13)) GO TO 36
C     ELEMENT IS  Cd
      WT(L) = 112.40
      GO TO 2990
   36 DO 37 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
   37 CONTINUE
C *** ELEMENT IS CARBON
   39 WT(L) = 12.01
      GO TO 2990
   40 IF(I.EQ.4) GO TO 43
      DO 42 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
   42 CONTINUE
C *** FIRST LETTER IS D, NO SECOND LETTER IN COLS 2-4
   43 WT(L) = 2.01
      IHAT(L) = 1
      GO TO 2990
C *** FIRST LETTER IS F; ELEMENT F OR FE
   50 IF(I.EQ.4) GO TO 58
      IF(ATXX(II).NE.SSYM(3).AND.ATXX(II).NE.SLCSYM(3)) GO TO 55
      WT(L) = 55.85
      GO TO 2990
   55 DO 57 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
   57 CONTINUE
C ***  FIRST LETTER F, NO SECOND LETTER IN COLUMNS 2-4
   58 WT(L) = 19.0
      GO TO 2990
   60 IF(I.EQ.4) GO TO 17
      IF(ATXX(II).NE.SSYM(1).AND.ATXX(II).NE.SLCSYM(1)) GO TO 63
      WT(L) = 69.72
      GO TO 2990
   63 IF(ATXX(II).NE.SSYM(3).AND.ATXX(II).NE.SLCSYM(3)) GO TO 17
      WT(L) = 72.59
      GO TO 2990
   70 IF(I.EQ.4) GO TO 73
      DO 72 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
   72 CONTINUE
C *** FIRST LETTER IS H, NO SECOND LETTER IN COLS 2-4
   73 WT(L) = 1.01
      IHAT(L) = 1
      GO TO 2990
   80 IF(I.EQ.4) GO TO 88
      IF(ATXX(II).NE.SSYM(7).AND.ATXX(II).NE.SLCSYM(7)) GO TO 83
      WT(L) = 114.82
      GO TO 2990
   83 IF(ATXX(II).NE.SSYM(9).AND.ATXX(II).NE.SLCSYM(9)) GO TO 85
      WT(L) = 192.22
      GO TO 2990
   85 DO 87 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
   87 CONTINUE
C *** FIRST LETTER IS I, NO SECOND LETTER IN COLS 2-4
   88 WT(L) = 126.9
      GO TO 2990
   90 IF(I.EQ.4) GO TO 93
      DO 92 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
   92 CONTINUE
C *** FIRST LETTER IS K, NO SECOND LETTER IN COLS 2-4
   93 WT(L) = 39.1
      GO TO 2990
  100 IF(I.EQ.4) GO TO 17
      IF(ATXX(II).NE.SSYM(5).AND.ATXX(II).NE.SLCSYM(5)) GO TO 17
C *** FIRST LETTER IS L, SECOND IS I
      WT(L) = 6.94
      GO TO 2990
  110 IF(I.EQ.4) GO TO 17
C ***  FIRST LETTER IS M
      IF(ATXX(II).NE.SSYM(4).AND.ATXX(II).NE.SLCSYM(4)) GO TO 113
      WT(L) = 24.31
      GO TO 2990
  113 IF(ATXX(II).NE.SSYM(7).AND.ATXX(II).NE.SLCSYM(7)) GO TO 115
      WT(L) = 54.94
      GO TO 2990
  115 IF(ATXX(II).NE.SSYM(8).AND.ATXX(II).NE.SLCSYM(8)) GO TO 17
      WT(L) = 95.94
      GO TO 2990
  120 IF(I.EQ.4) GO TO 128
      IF(ATXX(II).NE.SSYM(1).AND.ATXX(II).NE.SLCSYM(1)) GO TO 123
      WT(L) = 22.99
      GO TO 2990
  123 IF(ATXX(II).NE.SSYM(5).AND.ATXX(II).NE.SLCSYM(5)) GO TO 125
      WT(L) = 58.71
      GO TO 2990
  125 IF(ATXX(II).NE.SSYM(12).AND.ATXX(II).NE.SLCSYM(12)) GO TO 126
      WT(L) = 92.91
      GO TO 2990
  126 DO 127 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
  127 CONTINUE
C ***  FIRST LETTER IS N, NO SECOND LETTER IN COLS 2-4
  128 WT(L) = 14.01
      GO TO 2990
  130 IF(I.EQ.4) GO TO 133
      IF(ATXX(II).NE.SSYM(10).AND.ATXX(II).NE.SLCSYM(10)) GO TO 131
      WT(L) = 190.2
      GO TO 2990
  131 DO 132 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
  132 CONTINUE
C *** FIRST LETTER IS O, NO SECOND LETTER IN COLS 2-4
  133 WT(L) = 16.00
      GO TO 2990
  140 IF(I.EQ.4) GO TO 148
      IF(ATXX(II).NE.SSYM(13).AND.ATXX(II).NE.SLCSYM(13)) GO TO 143
      WT(L) = 106.4
      GO TO 2990
  143 IF(ATXX(II).NE.SSYM(15).AND.ATXX(II).NE.SLCSYM(15)) GO TO 146
      WT(L) = 195.09
      GO TO 2990
  146 DO 147 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
  147 CONTINUE
C *** FIRST LETTER IS P, NO SECOND LETTER IN COLS 2-4
  148 WT(L) = 30.97
      GO TO 2990
  150 IF(I.EQ.4) GO TO 159
      IF(ATXX(II).NE.SSYM(2).AND.ATXX(II).NE.SLCSYM(2)) GO TO 151
      WT(L) = 44.96
      GO TO 2990
  151 IF(ATXX(II).NE.SSYM(3).AND.ATXX(II).NE.SLCSYM(3)) GO TO 152
      WT(L) = 78.96
      GO TO 2990
  152 IF(ATXX(II).NE.SSYM(5).AND.ATXX(II).NE.SLCSYM(5)) GO TO 153
      WT(L) = 28.09
      GO TO 2990
  153 IF(ATXX(II).NE.SSYM(12).AND.ATXX(II).NE.SLCSYM(12)) GO TO 154
      WT(L) = 121.75
      GO TO 2990
  154 IF(ATXX(II).NE.SSYM(7).AND.ATXX(II).NE.SLCSYM(7)) GO TO 155
      WT(L) = 118.69
      GO TO 2990
  155 IF(ATXX(II).NE.SSYM(9).AND.ATXX(II).NE.SLCSYM(9)) GO TO 157
      WT(L) = 87.62
      GO TO 2990
C *** FIRST LETTER IS S, SECOND NOT C, E, I, B, N, OR R
  157 DO 158 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
  158 CONTINUE
C *** NO SECOND LETTER IN COLS 2-4; ELEMENT IS SULFUR
  159 WT(L) = 32.06
      GO TO 2990
  160 IF(I.EQ.4) GO TO 17
      IF(ATXX(II).NE.SSYM(5).AND.ATXX(II).NE.SLCSYM(5)) GO TO 165
      WT(L) = 47.90
      GO TO 2990
  165 IF(ATXX(II).NE.SSYM(3).AND.ATXX(II).NE.SLCSYM(3)) GO TO 17
      WT(L) = 127.60
      GO TO 2990
  170 IF(I.EQ.4) GO TO 178
      DO 174 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
  174 CONTINUE
C *** FIRST LETTER IS V, NO SECOND LETTER IN COLUMNS 2-4
  178 WT(L) = 50.94
      GO TO 2990
  180 IF(I.EQ.4) GO TO 17
      IF(ATXX(II).NE.SSYM(7).AND.ATXX(II).NE.SLCSYM(7)) GO TO 185
C *** FIRST LETTER IS Z, SECOND IS N
      WT(L) = 65.37
      GO TO 2990
  185 IF(ATXX(II).NE.SSYM(9).AND.ATXX(II).NE.SLCSYM(9)) GO TO 17
C *** FIRST LETTER IS Z, SECOND IS R
      WT(L) = 91.22
      GO TO 2990
  190 IF(I.EQ.4) GO TO 17
C ***  INITIAL LETTER IS  R
      IF(ATXX(II).NE.SSYM(12).AND.ATXX(II).NE.SLCSYM(12)) GO TO 192
      WT(L) = 85.47
      GO TO 2990
  192 IF(ATXX(II).NE.SSYM(3).AND.ATXX(II).NE.SLCSYM(3)) GO TO 194
      WT(L) = 186.21
      GO TO 2990
  194 IF(ATXX(II).NE.SSYM(14).AND.ATXX(II).NE.SLCSYM(14)) GO TO 196
      WT(L) = 102.91
      GO TO 2990
  196 IF(ATXX(II).NE.SSYM(11).AND.ATXX(II).NE.SLCSYM(11)) GO TO 17
      WT(L) = 101.07
      GO TO 2990
  200 IF(I.EQ.4) GO TO 204
      DO 202 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
  202 CONTINUE
C *** FIRST LETTER IS W, NO SECOND LETTER IN COLUMNS 2-4
  204 WT(L) = 183.85
      GO TO 2990
  210 IF(I.EQ.4) GO TO 214
      DO 212 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
  212 CONTINUE
C *** FIRST LETTER IS Y, NO SECOND LETTER IN COLUMNS 2-4
  214 WT(L) = 88.91
      GO TO 2990
 2900 CONTINUE
C ***  IF HERE, FOUR BLANKS AT START, UNRECOGNIZED ATOM
      NB = NB + 1
      NN = NN + 1
      NSYM(NN) = L
      GO TO 3000
 2910 NSP = NSP + 1
      IF(ABS(WT(L)).LT.2.2) IHAT(L) = 1
C ***  RECOGNIZE H OR D ON INPUT WHEN WT IS NEGATIVE AS WELL. NOTE THAT
C ***    ANY ATOM WITH WT -1. OR -2. WILL HENCE BE CONSIDERED H OR D BY
C ***    SUBROUTINE DISCOR, WHICH CHECKS "IHAT"
      GO TO 3010
C ***  TALLY ATOMS THAT HAVE BEEN ASSIGNED ATOMIC WEIGHTS
 2990 N = N + 1
C *** SET WEIGHT NEGATIVE FOR ISOTROPIC ATOMS
C ***        SET IHPR NON-ZERO IF ANISO H OR D PRESENT
 3000 IF(IB.LT.4) GO TO 3005
      IF(UOBS(L,2).NE.0.0.AND.IHAT(L).NE.0) IHPR = 1
      IF(UOBS(L,2).NE.0.0.OR.WT(L).LE.0.0) GO TO 3010
      NISO = NISO + 1
      WT(L) = -WT(L)
      GO TO 3010
 3005 IF(B22(L).NE.0.0.AND.IHAT(L).NE.0) IHPR = 1
      IF(B22(L).NE.0.0.OR.WT(L).LE.0.0) GO TO 3010
      NISO = NISO + 1
      WT(L) = - WT(L)
 3010 CONTINUE
C *** NOW PRINT NUMBERS OF ATOMS NOT ASSIGNED WTS HERE
      IF(NSP.EQ.0) GO TO 315
      WRITE(LO,310) NSP
  310 FORMAT(1H ,I4,' ATOMS HAD PREASSIGNED ATOMIC WTS OF 800.0, 999.9 O
     1R NEGATIVE')
  315 IF(NISO.EQ.0) GO TO 330
      WRITE(6,318) NISO
  318 FORMAT(1H ,I4,' ISOTROPIC ATOMS HAD WEIGHTS MADE NEGATIVE')
  330 IF(NB.EQ.0) GO TO 350
      WRITE(LO,320) NB
  320 FORMAT(1H ,I4,' ATOMS HAD BLANK NAMES')
  350 IF(NN.EQ.0) GO TO 450
      DO 400 I = 1,150
      IF(NSYM(I).NE.0) GO TO 400
      KK = I
      GO TO 420
  400 CONTINUE
  420 IF(KK.EQ.1) GO TO 450
      K = KK - 1
      WRITE(LO,430) NN
      WRITE(LO,435) (NSYM(I), I = 1,K)
  430 FORMAT(1H ,'SERIAL NUMBERS OF THE',I4,' UNRECOGNIZED ATOMS THAT WE
     1RE NOT ASSIGNED ATOMIC WEIGHTS BY THIS PROGRAM ARE:',//)
  435 FORMAT(5X,20I6)
  450 WRITE(LO,440) N
  440 FORMAT(1H ,I4,'  ATOMS WERE ASSIGNED ATOMIC WEIGHTS')
      RETURN
      END
